var D=document, W=window;
if(!W.lFunc) W.lFunc=function(){}

/**
* General purpose functions
*/
function dgi(o){return document.getElementById(o)}

// D.getElementsByName, use nb="all" to get array
function dgn(obn,nb){
	var o=D.getElementsByName(obn)
	if(!o.length) return;
	if(nb=='all') return o;
	return o[(nb==undefined || isNaN(nb))?0:nb];
}

// Count associative array items
function count(a){var n=0;	for(e in a) n++; return n;}
// String trim
String.prototype.trim=function (){return this.replace(/^\s+|\s+$/,'');};
// Stop all pending connections to server
function windowStop(){if(W.stop) W.stop(); else D.execCommand("Stop");wl.asr.cancelAll()}
// Ping server
function ping() {sendData('rnd='+Math.random(), '/ping.php', true)}

// Right-click hook: if a function called 'onrightclick' exists, call it
D.oncontextmenu=function(e){if(W.onrightclick && ((e && e.which == 3)||(W.event && (event.button==0||event.button==2)))) return onrightclick(e); else return true}

if(!W.cfDbg) {function cfDbg(){}} // prod: Define fake debug function to avoid issues with uncleaned debug functions in released code


/**
* DOM Functions
*/
function removeNode(n){if(n.parentNode) n.parentNode.removeChild(n)}

// Get actual style value
function getElementStyle(elem, styleProp, keepPx) {
	if(!elem) return false;
	try{
		if(phpBrowser=='ie' && styleProp.indexOf('-')!=-1){
			styleProp=styleProp.substr(0,styleProp.indexOf('-'))+styleProp.substr(styleProp.indexOf('-')+1,1).toUpperCase()+styleProp.substr(styleProp.indexOf('-')+2);
		}

		if(W.getComputedStyle) es=W.getComputedStyle(elem, "").getPropertyValue(styleProp); // Gecko
		else if (elem.currentStyle)  es=elem.currentStyle[styleProp];// Opera & IE
		else return '';

		if(!keepPx && es.substr(es.length-2)=='px') es=es.substr(0,es.length-2);
		else if(!keepPx && es.substr(es.length-2)=='em') {	es=es.substr(0,es.length-2)*getElementStyle(elem,'font-size');}

		if(keepPx===false && es=='auto') return 0;
		return es;
	}
	catch(err){/*alert(err.description)*/}
}


// Get actual left offset
function actualOffsetLeft(node){
	var l=0,t='';
	while(node)	{
		l+=node.offsetLeft;

//t+='('+node.innerHTML.substr(0,19).replace(/</,'&lt;')+' => '+node.offsetLeft+' comp='+getElementStyle(node,'overflow')+')'
		ov=getElementStyle(node,'overflow');
		//if(node.style && ((ov=node.style.overflow)=='scroll' || ov=='auto')) l-=(node.scrollLeft)
		if(ov=='scroll' || ov=='auto') l-=(node.scrollLeft)
		node=node.offsetParent;
	}

	return l;
}
// Get actual right offset
function actualOffsetRight(node){return actualOffsetLeft(node)+node.offsetWidth}

// Get actual top offset
function actualOffsetTop(node){
	var t=0;
	while(node)	{
		t+=node.offsetTop;
		if(!(node=node.offsetParent)) break;
		if(node.style && ((ov=node.style.overflow)=='scroll' || ov=='auto')) t-=(node.scrollTop)
	}
	return t;
}
// Get actual bottom offset
function actualOffsetBottom(node){return actualOffsetTop(node)+node.offsetHeight}
function actualRect(node){
	var rect={x:0,y:0,w:node.offsetWidth,h:node.offsetHeight};
	while(node)	{
		rect.x+=node.offsetLeft;
		rect.y+=node.offsetTop;
		if((ov=node.style.overflow)=='scroll' || ov=='auto') {
			rect.x-=(node.scrollLeft)
			rect.y-=(node.scrollTop)
		}
		node=node.offsetParent;
	}
	return rect;
}
function setActualHeight(node, h){
	if(phpBrowser!=="ie" && !$(node).e.className().has('boxSizing'))
		h-=(1*getElementStyle(node,'padding-top') + 1*getElementStyle(node,'padding-bottom'));
		if(!isNaN(getElementStyle(node,'border-top-width')))  h-=1*getElementStyle(node,'border-top-width')
		if(!isNaN(getElementStyle(node,'border-bottom-width')))  h-=1*getElementStyle(node,'border-bottom-width')
	try{node.style.height = h+'px'} catch(err){};
}
function setActualWidth(node, w){
	if(phpBrowser!=="ie" && !$(node).e.className().has('boxSizing'))
		w-=getElementStyle(node,'padding-left') + getElementStyle(node,'padding-right')
	try{node.style.width=w+'px'} catch(err){};
}
function isParent(pn,cn){
	var n=cn; var i=10;
	while(--i&&(n=n.parentNode)) if(n==pn) return 1;
	return 0;
}
function alignBottom(childN, parentN, margin, minHeight){
	var h;
	if(!childN || !parentN) return;
	if(!margin) margin=0;
	if(W.winMe && parentN==winMe) h=winMe.getInnerHeight();
	else h=actualOffsetBottom(parentN)-getElementStyle(parentN,'padding-bottom',false);

	h+=-actualOffsetTop(childN)-getElementStyle(childN,'margin-bottom',false)-margin;

	if(minHeight) h=Math.max(minHeight,h)
	setActualHeight(childN,h);
	return h;
}

/**
 * Connect listener to object. Added support for cross-browser onmouseenter & onmouseleave
 * Args:
 * 	node
 * 	event name (with or without "on")
 * 	callback function.
 */
function connect() {
    var a = arguments;
    if(a.length<3) return;
    if(a[1].substr(0,2)=='on') a[1]=a[1].substr(2);
    if(phpBrowser.substr(0,2)!='ie' && (a[1]=='mouseenter'||a[1]=='mouseleave')) {
        a[2]=mouseEnter(a[2]);
        a[1]=(a[1]=='mouseenter')?'mouseover':'mouseout';
    }
    return D.addEventListener?a[0].addEventListener(a[1],a[2],a[3] || false):a[0].attachEvent?a[0].attachEvent('on' + a[1], a[2]): false;
}

// Disconnect listener from object. args: node, event name (with or without "on")
function disconnect() {
	var a = arguments;
	if(a[1].substr(0,2)=='on') a[1]=a[1].substr(2);
	return D.removeEventListener?a[0].removeEventListener(a[1],a[2],a[3] || false):a[0].detachEvent?a[0].detachEvent('on' + a[1], a[2]): false;
}
// Cross browser stopPropagation function
function stopPropagation(e){
	if(!e) e=W.event; if(!e) return;
	e.cancelBubble=true; e.returnValue=false; // IE
	if (e.stopPropagation){e.stopPropagation();e.preventDefault()} // Others
	return false;
}
// Cross-browser mouse enter/leave function, used by connect()
function mouseEnter(f){
    return function(_evt){
		var rT = _evt.relatedTarget;
		if (this !== rT && !$(this).e.isChildOf(rT)) f.call(this, _evt);
    }
};

/**
 * Odd/Even list hover
 */
var currentHover=0;
function eHover(e){
	if(!e) {if(currentHover) eHoverO(currentHover); currentHover=0; return}
	var targ=e.target||e.srcElement;

	var limit=10;
	while(--limit>0 && targ && (!targ.getAttribute || !targ.getAttribute('eH'))) targ=targ.parentNode;
	//alert(dbgObj(targ))
	if(limit && targ){
		if(!targ.id) targ.id="H"+Math.random();// Create id if element doesn't have one
		if(targ.id && currentHover!=targ.id) eHoverI(targ.id);
		if(currentHover && currentHover!=targ.id) {eHoverO(currentHover); currentHover=0;}
		currentHover=targ.id;
	}
	else if(currentHover) {eHoverO(currentHover); currentHover=0;}
}
// Hover in
function eHoverI(objectid, classToSet){
	if((W.dragInProgress && dragInProgress) || !(obJ=dgi(objectid))) return;
	var cClass=obJ.className; var rClass='';
	if((spP=cClass.indexOf(' '))!=-1) {rClass=cClass.substr(spP);cClass=cClass.substr(0,spP);}
	if(classToSet) return obJ.className=classToSet+rClass;
	if(cClass.length<5 || cClass.substr(cClass.length-5,5)!='Hover') obJ.className=cClass + 'Hover'+rClass;
}
// Hover out
function eHoverO(objectid, classToSet){
	// If a context menu is displayed, don't unselect line: used not to unselect item when showing context menu in explorers
	if(dgi('contextMenuDiv')){
		setTimeout(function(){eHoverO(objectid, classToSet)},100)
		return;
	}

	if(!(obJ=dgi(objectid)) || (W.dragInProgress && dragInProgress)) return;
	var cClass=dgi(objectid).className; var rClass='';
	if((spP=cClass.indexOf(' '))!=-1) {rClass=cClass.substr(spP);cClass=cClass.substr(0,spP);}
	if(classToSet) return dgi(objectid).className=classToSet+rClass;
	if(cClass.substr(cClass.length-5,5)=='Hover') dgi(objectid).className=cClass.substr(0,cClass.length-5)+rClass;
}
// Change an image or IE6 png span SRC
function changeImgSrc(id,imgUrl){
	if(dgi(id).tagName.toLowerCase()=='img') dgi(id).src=imgUrl;
	else {
		var filter=dgi(id).style.filter;
		var s=filter.indexOf("src='")+5;
		var e=filter.indexOf("'",s);
		dgi(id).style.filter=filter.substr(0,s) + imgUrl + filter.substr(e);
	}
}

/**
* Collapse TD
* @param id: id of folded / unfolded TD
*/
function toggleTD(id){
	var cTD=dgi(id)/* folded / unfolded TD /*/, cTDS=cTD.style, ctrl=dgi(id+'_colTD') /* handle TD */,isFolded=(cTDS.display=='none'),extraParameters={},cTDDiv1S,cTDDiv2,cTDDiv2S,baseWidth;

	ctrl.lastChild.className=isFolded?'colTDUF':'colTDF';
	ctrl.title=isFolded?hideCaption:showCaption;

	// Toggle server-side state
	sendData("toggleTD=1&"+id+"="+(isFolded?1:0),PHP_SELF,0);

	// Add a double div wrapper into collapsed TD so width can be properly set
	if(cTD.firstChild.id!==id+'_colTDD1'){
		cTD.innerHTML='<div id="'+id+'_colTDD1" style="overflow:hidden;position:relative"><div id="'+id+'_colTDD2">'+cTD.innerHTML+'</div></div>';
	}
	cTDDiv1S=dgi(id+'_colTDD1').style;
	cTDDiv2=dgi(id+'_colTDD2');	cTDDiv2S=cTDDiv2.style;

	// Unfolding
	if(isFolded){
		// Compute unfolded width
		cTDS.width=cTDDiv1S.width='1px';
		cTDDiv2S.position='absolute'
		//cTDDiv2S.visibility='hidden';
		cTDS.display=isFolded?'':'none';
		baseWidth=cTDDiv2.offsetWidth;
		cTDDiv2S.position='';

		wl.anim({'item':cTD,
				'duration':500,
				'extraParameters':{'baseWidth':baseWidth},
				'callbackComplete':function(){if(W.winResized) winResized();if(W.dd) dd.recalc()},
				'function':function(p,anim){
					p=Math.max(1,(anim.extraParameters.baseWidth*wl.animFunctionUnfold1(p)))+'px';
					cTDDiv1S.width=p;

					return {'width':p}
				}
		});
	}
	// Folding
	else{
		baseWidth=cTD.offsetWidth
		extraParameters.startW=cTD.offsetWidth;
		cTDDiv1S.width=baseWidth+'px';

		wl.anim({'item':cTD,
				'duration':500,
				'extraParameters':{'baseWidth':baseWidth},
				'callbackComplete':function(){
					cTDS.display='none';
					if(W.winResized) winResized();if(W.dd) dd.recalc()
				},
				'function':function(p,anim){
					p=Math.max(1,(anim.extraParameters.baseWidth*wl.animFunctionFold1(p)))+'px';
					cTDDiv1S.width=p;
					return {'width':p}
				}
		});
	}

	if(W.winResized) winResized();
}
function toggleTDHL(n){
	var id=n.id;
	if(!id) return;
	id=id.substr(0,id.length-6);
	if(dgi(id).style.display=='none') {
		if(!dd.obj || dd.obj.id!=='dragMaskDiv') toggleTD(id);
	}
}
lFunc('common',10);



/**
* Fade in-out (0 <= alpha <= 1)
* n: item or id of item
* aSt: alpha start
* aEn: alpha target
* nbSteps: nb of steps
* cb: js callback on completition (eval'ed)
* stepCb: js callback on each step (eval'ed)
*/
function fade(n, aSt, aEn, nbSteps, cb, stepCb, aCur){
	var s,ini,finished=0,i;

	if(typeof(n)=='object'){if(n.id) i=n.id; else i=n.id='id'+Math.floor(999999*Math.random());}
	else {i=n;n=dgi(i)}
	if(!n || (wl.fadeItems[i] && wl.fadeItems[i]!=aEn)) return; // Inexisting item or another fadeto has set a new target alpha
	s=n.style;

	// Simple onload fade: use new animation function
	if(aSt===undefined){
		if($(n).e.getStyle('visibility')!=='visible') s.visibility='visible';
		if($(n).e.getStyle('display')=='none') s.display='inline';
		wl.anim({'item':n,'duration':500,'function':function(p,a){return {'opacity':p}}});
		return;
	}

	if(aSt==undefined) {aSt=0;aEn=1}
	if(aEn==undefined) aEn=aSt;
	if(nbSteps==undefined) {
		if(aSt==aEn) nbSteps=1; else nbSteps=imgFadeSteps;
	}

	if(aCur==undefined) {aCur=aSt;ini=1;}
	aCur+=(aEn-aSt)/nbSteps;

	if(!n) return;

	if(aEn  > aSt && aCur >= aEn){finished=1;aCur=aEn;}
	if(aEn <= aSt && aCur <= aEn){finished=1;aCur=aEn;}
	setAlpha(n,aCur);

	if(aCur>0 && ini && (s.display=="none" || s.visibility!="visible")) {s.display=""; s.visibility="visible"}
	if(aCur==0) s.display="none";

	if(!finished) W.setTimeout('fade("'+ i +'", '+aSt+', '+aEn+', '+nbSteps+', \''+cb+'\', \''+stepCb+'\', '+aCur+')',5);
	else{
		if(cb!==undefined && cb!==false) eval(cb);
		if(wl.fadeItems[i]!==undefined) delete(wl.fadeItems[i]);
	}
	if(stepCb) eval(stepCb);
}

// Set opacity (0<=alpha<=1)
function setAlpha(n,alpha){
	with(n.style){
		if(alpha==1) {
			var s
			if((s=n.getAttribute('style')) && s.removeAttribute) s.removeAttribute('filter')
			opacity=1;

		}
		else {
			filter="Alpha(opacity="+(Math.round(100*alpha))+")";
			opacity=Math.round(100*alpha)/100;
		}
	}
}
/**
* Fold/unfold
* @param itemId: id of item to fold
* @param onFoldedFunction: name of function to call when folding is done (or "displayNone" to set display=none)
*/
function fold(itemId,onFoldedFunction,step){
	var item=dgi(itemId);
	if(item.style.overflow!='hidden') item.style.overflow='hidden';
	var h=item.offsetHeight;

	if(!step) step=1; else step++;

	if(h<11 || step>20){
		item.style.height='0';
		if(onFoldedFunction) {
			if(onFoldedFunction=='displayNone') item.style.display='none';
			else eval(onFoldedFunction+'("'+itemId+'")');
		}
	}
	else{
		item.style.height=(h*0.6)+'px';
		W.setTimeout('fold("'+itemId+'","'+((onFoldedFunction)?onFoldedFunction:"")+'",'+step+')',1);
	}
}
function unfold(itemId,unfoldedHeight,onUnFoldedFunction){
	var item=dgi(itemId);
	if(item.style.overflow!='hidden') item.style.overflow='hidden';
	var h=Math.max(item.offsetHeight,10)*1.4;

	if(h>=unfoldedHeight){
		item.style.unfoldedHeight=h+'px';
	}
	else{
		item.style.height=h+'px';
		W.setTimeout('unfold("'+itemId+'",'+unfoldedHeight+((onUnFoldedFunction)?',"'+onUnFoldedFunction+'")':')'),1);
	}
}


/**
* Buttons (bt)
*/
function btEnable(id){
	dgi(id).getElementsByTagName('a')[0].className="up";
	if(dgi(id).getElementsByTagName('legend')[0].innerHTML) dgi(id).getElementsByTagName('a')[0].href=dgi(id).getElementsByTagName('legend')[0].innerHTML;
}
function btDisable(id){
	dgi(id).getElementsByTagName('a')[0].className="off";
	if(dgi(id).getElementsByTagName('a')[0].href!="javascript:;") dgi(id).getElementsByTagName('legend')[0].innerHTML=dgi(id).getElementsByTagName('a')[0].href;
	dgi(id).getElementsByTagName('a')[0].href="javascript:;";
}
function btActivate(id){
	if(dgi(id).getElementsByTagName('a')[0].className=="off"){
		if(dgi(id).getElementsByTagName('legend')[0].innerHTML) dgi(id).getElementsByTagName('a')[0].href=dgi(id).getElementsByTagName('legend')[0].innerHTML;
	}
	dgi(id).getElementsByTagName('a')[0].className="on";
}
function btState(id){return dgi(id).getElementsByTagName('a')[0].className;}
function btSetCaption(id,t){
	dgi(id).getElementsByTagName('q')[0].innerHTML=t;
	if(phpBrowser=='ie') dgi(id).getElementsByTagName('s')[0].innerHTML=t;
	btAdjustText(id);
}
function btSetIcon(id,s){
	if(dgi(id).getElementsByTagName('IMG').length) dgi(id).getElementsByTagName('IMG')[0].src=s;
	else dgi(id).getElementsByTagName('SPAN')[0].style.filter="progid:DXImageTransform.Microsoft.AlphaImageLoader(src="+s+")";
	btAdjustText(id);
}
function btAdjustText(id){
	if(phpBrowser=='ie') return;
	var txt=dgi(id).getElementsByTagName('s')[0].innerHTML;
	if(dgi(id).getElementsByTagName('q')[0].innerHTML.length) txt=dgi(id).getElementsByTagName('q')[0].innerHTML;
	else dgi(id).getElementsByTagName('q')[0].innerHTML=txt;

	dgi(id).getElementsByTagName('s')[0].innerHTML=txt;

	var txtArea=dgi(id).getElementsByTagName('s')[0];
	var buttonArea=dgi(id).getElementsByTagName('u')[0];

	var dots='...';
	if(!dgi(id).title) dgi(id).title=txt;
	while(txtArea.offsetLeft+txtArea.offsetWidth>buttonArea.offsetLeft){
		txt=txt.substr(0,txt.length-1);
		txtArea.innerHTML=txt+dots;
		if(!txt.length) {
			if(dots.length) dots=dots.substr(0,dots.length-1);
			else  {
				txtArea.innerHTML='&nbsp;';
				break;
			}
		}
	}
}
function btSetWidth(id, newWidth){
	if(!dgi(id)) return;
	dgi(id).getElementsByTagName('DIV')[0].style.width=newWidth
}
function btClick(id){eval(dgi(id).getElementsByTagName('A')[0].href)}


/**
* Progress bar (note: 0 < perc < 100)
*/
function progressSetText(id,txt){dgi(id+'_text').innerHTML=txt;}
function progressGetText(id){return dgi(id+'_text').innerHTML}
function progressSetPerc(id,perc){dgi(id+'_inner').style.width=(perc)+'%'}
function progressGetPerc(id){var p=dgi(id+'_inner').style.width;return p.substr(0,p.length-1)}


/**
* CONTEXT MENU
*/
var contextMenuDOC,contextMenuTime,contextMenuObject;
function ContextMenuKD(e){
	if(wl.eventKC(e)==27) contextMenuObject.remove();
	if(wl.eventKC(e)==13) {
		var it=contextMenuObject.items;
		for (i=0;i<it.length;i++) if(it[i]['def']) {contextMenuObject.remove();eval(it[i]['action']);return;}
	}
}

/**
 * Context menu item
 */
function ContextMenuItem(ico,caption,action,def,id){
	if(ico==='sep') return ico;
	if(!id) id='cmi'+Math.random();
	return {'icon':ico,'caption':caption,'action':action,'def':def,'id':id}
}

/* Context menu item
 * items: array of context menu items
 * opts: assoc array of options :
 	button=>node to attach as drop-down menu
 	align=>'right' or 'left':drop-down menu alignement
 */
function ContextMenu(items,opt){
	var o='',it,e;

	this.remove=function(e){
		if(wl.chrono.microtime()-contextMenuTime<100) return;
		disconnect(D,'keydown',ContextMenuKD)
		wl.mask.hide();
		if(dgi('contextMenu')) removeNode(dgi('contextMenu'))
		if(contextMenuDOC) D.onclick=contextMenuDOC;
	}
	if(!items) return;
	var x=W.mouseX,y=W.mouseY;
	if(x==undefined && !opt['button']) return;

	this.items=items;

	// Remove previous context menu if any
	if(dgi('contextMenu')) this.remove();

	if(!opt) opt={};
	var cm=D.createElement('DIV');
	cm.id='contextMenu';
	cm.className='dropShadow';
	with(cm.style){visibility='hidden';top=0;left=0;}

	o+='<div class="contextMenu" id="contextMenuDiv">';
	for(var i=0;i<items.length;i++){
		if((it=items[i])=='sep') {
			if(i+1<items.length && i>0 && items[i-1]!='sep') o+='<div class="sep"></div>';
		}
		else if(it['action']){
			o+='<a href="javascript:(new ContextMenu()).remove();'+it['action']+'"'+((it['def'])?' class="default"':'')+'>';
			o+='<img src="'+(it['icon']||'/gfx/v.gif')+'">'+it['caption']+'</a>';
		}
		else o+='<div class="disabled"><img src="'+(it['icon']||'/gfx/v.gif')+'">'+it['caption']+'</div>';
	}
	o+='</div>';
	//o+='</td><td class="sIEr">&nbsp;</td></tr><tr class="sIEtrb"><td class="sIEb"></td><td class="sIErb"></td></tr></table>';
	cm.innerHTML=o;
	contextMenuTime=wl.chrono.microtime()
	wl.mask.show(1,0,false,this.remove)

	D.body.appendChild(cm);

	// Extra style
	if(opt.style) for(e in opt.style) cm.style[e]=opt['style'][e];
	// Set menu position
	with(cm.style){
		zIndex=wl.mask.node().style.zIndex+1;
		if(opt['button']){
			y=actualOffsetBottom(opt['button']);
			if(opt['align']=='right')
				x=actualOffsetRight(opt['button'])-cm.offsetWidth;
			else
				x=actualOffsetLeft(opt['button']);

		}
		else{
			if(opt['centerFirst']) {x-=12;y-=dgi("contextMenuDiv").firstChild.offsetHeight/2}
			x=Math.min(x,dd.getWndW()-cm.offsetWidth)
			y=Math.min(y,dd.getWndH()-cm.offsetHeight-20);
		}
		left=x+'px';top=y+'px' ;
	}

	// Egalize all items widths in IE
	if(phpBrowser=='ie'){
		var sn=cm.firstChild.childNodes,mw=0,e;
		for(e in sn) mw=Math.max(mw,sn[e].offsetWidth||0);
		if(opt.style && opt.style.width) mw=opt.style.width;
		for(e in sn) if(sn[e].nodeType==1) sn[e].style.width=mw+'px';
		cm.style.visibility='visible';// IE8 WA
	}
	// IE9+ fix
	if(phpBrowser=='ie+') setTimeout(function(){dgi('contextMenu').style.width=(dgi('contextMenu').offsetWidth)+'px'},10)

	if(opt['fade']) {
		wl.anim({'item':cm,'duration':200,'function':function(p,a){
			return {'visibility':'','opacity':p}}
		});
	}
	else cm.style.visibility='';

	connect(D,'keydown',ContextMenuKD,false);
	contextMenuObject=this;
}
// Attach a context menu to a given node
function ContextMenuAttach(n,items,opt){
	if(typeof(n)=='string') n=dgi(n); if(!n) return;
	if(!opt) opt={}; if(opt['button'] && (typeof opt.button)!='object') opt['button']=n;
	n.oncontextmenu=function(event){
		if(!event && W.event) event=W.event;
		var cm,t=(event.srcElement||event.target).tagName;
		if(t=='INPUT'||t=='TEXTAREA') return true;
		cm=new ContextMenu(items,opt);return false
	}
	if(opt['leftClick']) n.onclick=function(event){var cm=new ContextMenu(items,opt);return false}
}
// Attach a context menu to a given node
// node: node to attach menu
// items: array of ContextMenuItem
// opt: options (style: assoc array of style properties, button: 1 to attach as button drop-down list to node or otherNode to attach to another DOM node, leftClick to trigger on left click)
function ContextMenuDropDown(node,items,opt){
	if(typeof(node)=='string') node=dgi(node); if(!node) return;
	if(!opt) opt={};opt['button']=node;
	if(!opt['align']) opt['align']='left';
	node.onclick=function(event){var cm=new ContextMenu(items,opt);return false}
}

// Attach a context menu to a given node
function ContextMenuDetach(node){
	if(typeof(node)=='string') node=dgi(node); if(!node) return;
	node.oncontextmenu='';
}

/**
* Tooltip
*/
var tooltipDx=10;
var tooltipDy=10;
var tooltipDelay=500; 	// Delay before displaying tooltip (ms)
var tooltipNodeId=0;	// Node id of currently displayed or to-be-displayed tooltip
var tooltipShown=0; 	// 1 if tooltip is displayed
var tooltipContentFunction; // cache for tooltip text content function

/**
* @desc Mouseover function: entry-point for tooltip
*		 start timer to dispay tooltip
* @param DOMnode node
* @param string txtContent (optional): content of tooltip. If not set, content is set from tooltipGetContent function
* @param bool noDelay: true to display immediately
*/
var tooltipOnMouseDownFunction,tooltipOnMouseOutFunction; // Temp storage of onmouseout and onmousedown functions, converted to text
function tooltip(node, txtContent, noDelay){
	var ttSet=node.ttSet;

	if(!node || (!txtContent && !W.tooltipGetContent) || (W.winMe && !winMe.isActive())) return; // Wrong parameters / config

	if(!node.id) node.id='tooltip'+Math.floor(Math.random()*100000);
	if(tooltipNodeId==node.id) return; // Wrong parameters / config

	if(!ttSet) node.ttSet=1

	// If a tooltip is currently shown, destroy it first (should rarely happend)
	//if(tooltipShown) tooltipHide(tooltipNodeId,onmouseoutFunction,'out')

	tooltipNodeId=node.id;
	tooltipShown=0;

	/**
	* mouse out and click management
	*/
	if(!ttSet){
		connect(node,'mouseout',function(e){tooltipHide(node.id,'out')})
		connect(node,'onmousedown',function(e){tooltipHide(node.id,'down')})
	}
	// Delay-call tooltip show function
	tooltipContentFunction=null;
	if(!txtContent) txtContent='';
	if((typeof txtContent)!='string') {tooltipContentFunction=txtContent; txtContent=''}
	W.setTimeout('tooltipShow("'+node.id+'","'+txtContent.replace(/"/g,'\\"')+'",1)',((noDelay)?0:tooltipDelay)); /* \\"*/
}

lFunc('common',10);

// Show tooltip
function tooltipShow(nodeId,txtContent,calledByTimer){
	var tooltipDiv,node=dgi(nodeId),content;

	if(!node || (tooltipNodeId!=nodeId && calledByTimer) || tooltipShown) return; // Error or other tooltip requested since, or tooltip already shown

	// Hide context menu if any opened
	if(dgi('contextMenu')) (new ContextMenu()).remove();

	// Get tooltip content
	content=txtContent?txtContent:(W.tooltipContentFunction)?tooltipContentFunction(node):tooltipGetContent(node.id);

	// No tooltip content: tooltip should not be displayed
	if(!content) {
		if(calledByTimer && node.onmouseout!=null) node.onmouseout();
		return;
	}

	// Remove previous tooltip if existing
	tooltipDestroy();

	// Create container that will host tooltip node
	if(!dgi('dragDetach')) {
		var ddNode=D.createElement("div");
		ddNode.id="dragDetach";
		with(ddNode.style){position="absolute";top=0;left=0;zIndex=10000};
		D.body.appendChild(ddNode);
		wl.mask.moveAbove(ddNode);
	}

	// Create tooltip DOM node
	with(tooltipDiv=D.createElement("div")){
		id='tooltip';
		className='tooltip';
		style.display='none';
		style.width='400px';
		// Fill content
		innerHTML=content;
	}

	dgi('dragDetach').appendChild(tooltipDiv)

	// Set draggable
	ADD_DHTML('tooltip',1);

	dd.elements.tooltip.maximizeZ();

	// Set onmousemove function
	node.onmousemove=function(event){tooltipMove(nodeId)};

	tooltipShown=1;
	dgi('tooltip').style.display='block';
	if(dgi('tooltipLoading')) wl.loading.set('tooltipLoading');

	tooltipAdjustToContent();
	tooltipMove(nodeId);
}
function tooltipSetContent(h){
	var tt;
	if(!(tt=dgi('tooltip'))) return;
	with(tt.style) {visibility='hidden';top=0;left=0}
	tt.innerHTML=h;
	tooltipMove();
	return;
//	tooltipAdjustToContent();
}
function tooltipAdjustToContent(){
	var s=dgi('tooltip').style;
	s.width='auto';s.height=''
}
function tooltipMove(nodeId,force){
	if(!force){
		if(!nodeId) nodeId=tooltipNodeId;
		if(nodeId!=tooltipNodeId || !tooltipShown || !dgi('tooltip')) return;
	}
	var offsetX=(W.pageXOffset?W.pageXOffset:D.body.scrollLeft);
	var offsetY=(W.pageYOffset?W.pageYOffset:D.body.scrollTop);
	var ttx=mouseX+tooltipDx,tty=mouseY+tooltipDy,tt=dgi('tooltip');

	if(tty+tt.offsetHeight>offsetY+D.body.clientHeight) tty=offsetY+D.body.clientHeight-10-tt.offsetHeight;
	if(ttx+tt.offsetWidth>offsetX+D.body.clientWidth){
		if(tt.offsetWidth > D.body.clientWidth) {
			tt.style.whiteSpace='normal';
			tt.style.width=(Math.floor(0.9*D.body.clientWidth))+'px';
			ttx=(Math.floor(0.05*D.body.clientWidth))+'px';
		}
		else ttx=mouseX - tooltipDx - tt.offsetWidth;
	}
	dd.elements['tooltip'].moveTo(Math.max(5,ttx),tty);
}
function tooltipHide(nodeId,mouseXXX){
	var node;

	if(nodeId==tooltipNodeId) tooltipNodeId=0;
	tooltipShown=0;

	tooltipDestroy();

	if(!(node=dgi(nodeId))) return;
}
/**
* @desc Remove tooltip DOM node and DHTML element
*/
function tooltipDestroy(){
	if(dd.elements.tooltip) {
		dd.elements.tooltip.hide();
		dd.elements.tooltip.del(1);
	}
	if(dgi('tooltip')) $('tooltip').e.del();
}
/**
* @desc Fill tooltip with dedicated associative array
*/
function tooltipSetProperties(p){
	wl.loading.stop('tooltipLoading');

	function tooltipCleanCode(arr){
		for(elem in arr) {
			if(typeof(arr[elem])=='string'){
				if(arr[elem].substr(0,5)=='code:') arr[elem]=arr[elem].substr(5);
			}
			else tooltipCleanCode(arr[elem]);
		}
	}
	if(!dgi('tooltip')) return;

	//tooltipCleanCode(p)

	var content='';
	// Header
	content='<div class="tooltipHeader">'+((p['icon'])?'<img src="'+p['icon']+'" alt="" style="vertical-align:middle;margin-right:0.5em">':'')+((p['header'])?((p['header']['c'])?p['header']['c']:p['header']):p['filename'])+'</div>'
	var tURL='';
	for(elem in p) if(elem=='thumbnailURL') {tURL=p[elem];break}

	// Table for thumbnail + extra data
	if(tURL && p['extra']) content+='<table><tr style="vertical-align:top"><td style="padding-right:1em">';

	// Thumbnail
	if(tURL) {

		// If no extra data, center image
		if(!p['extra'] && tURL.substr(0,5)!='code:') content+='<center>';

		// Image border frame
		content+='<div class="tooltipImage"'+((p['thumbnailNoFrame'])?' style="border:0;padding:0;background:transparent"':'')+'>';
		// HTML code
		if(tURL.substr(0,5)=='code:'){
			content+=tURL.substr(5);
		}
		// URL
		else{
			content+='<img id="tooltipLoading" src="" style="position:absolute;margin-left:'+(Math.floor(p['thumbnailURLW']/2)-8)+'px;margin-top:'+(Math.floor(p['thumbnailURLH']/2)-8)+'px">';
			content+='<img id="tooltipImg" style="visibility:hidden" alt="" src="'+tURL+'" onload="tooltipImgLoaded()" width="'+p['thumbnailURLW']+'" height="'+p['thumbnailURLH']+'">';
		}
		content+='</div>';
		if(!p['extra'] && tURL.substr(0,5)!='code:') content+='</center>';
	}

	if(tURL && p['extra']) content+='</td><td>';

	// Extra content (right part of thumbnail)
	if(p['extra']){
		if(p['extra']['extraTitle']){
			content+='<b>'+p['extra']['extraTitle']['c']+'</b><br/>';
			delete(p['extra']['extraTitle']);
		}
		content+='<table style="font:inherit;vertical-align:top">';
		var nb=0;for(elem in p['extra']) nb++;
		var elemNb=0;
		for(elem in p['extra']){
			if(nb<24 || elemNb%2==0) content+='<tr><td style="padding-right:1em">';
			else content+='<td style="padding-right:1em;padding-left:3em">';

			if(p['extra'][elem]['v'])
			content+='<b>'+p['extra'][elem]['c']+'</b></td><td>'+p['extra'][elem]['v']+'</td>';
			else if(p['extra'][elem]['c']) content+='</td><td>'+p['extra'][elem]['c']+'</td>';
			else content+='<b>'+elem+'</b></td><td>'+p['extra'][elem]+'</td>';

			if(nb<24 || elemNb%2==1) content+='</tr>';
			elemNb++;
		}
		if(nb>23 && elemNb%2==0) content+='</tr>';
		content+='</table>';
	}

	if(tURL && p['extra']) content+='</td></tr></table>';

	// Footer
	if(p['footer']){
		content+='<div class="tooltipFooter">';
		if(p['footer']['c']) content+='<b>'+p['footer']['c']+'</b>'+p['footer']['v']; else content+=p['footer'];
		p['footer']+='</div>';
	}
	else if(p['cTime'] && p['mTime']){
		content+='<div class="tooltipFooter">';
		content+='<div style="width:30em;display:block;height:1px;overflow:hidden"></div>';
		content+='<div style="position:absolute;right:1em"><b>'+p['fileSize']['c']+p['sep']+'</b>'+p['fileSize']['v']+'</div>';
		content+='<div><b>'+p['cTime']['c']+p['sep']+'</b>'+p['cTime']['v']+'</div>';
		content+='<div><b>'+p['mTime']['c']+p['sep']+'</b>'+p['mTime']['v']+'</div>';
		content+='</div>';
	}


	// Set content and fade-in
	tooltipSetContent(content);
	wl.loading.set('tooltipLoading');
	fade('tooltip',0,1,3);
}
// Thumbnail image loaded
function tooltipImgLoaded(){
	var t=dgi("tooltipImg");
	if(!t) return;
	if(t.previousSibling) t.parentNode.removeChild(t.previousSibling);
	tooltipAdjustToContent();
	fade("tooltipImg",0,1,5)
}

/**
 * @Desc Create a tooltip for a given node
 */
function tooltipCreate(node,text,title,ico){
	if(title) title='<b>'+title+'</b><br>'; else title='';
	if(ico) title='<img src=\''+ico+'\' style=\'vertical-align:middle;margin-right:0.5em\'>'+title;
	if(!text) text='false';
	node.onmouseover=function(){tooltip(node,title+text,1)};
}

lFunc('common',10);

/**
* @desc dialog box
*
* @param: DialogBox object
* definition: array
* 	title(opt): box title
* 	text: main text,
* 	icon(opt): icon src,
* 	buttons: array:
* 		'ok'(opt): caption of ok button,
* 		'cancel'(opt): caption of cancel button
* 	check(opt): bool, true if default checked, false if default not checked
* 	checkText(opt): string: checkbox text
*
* @param callbackFunction (string): name of callback function called with array {'button':button} as parameter. If this function returns anything else thant undefined, dialog is not closed.
* @param array options: 'extraInput': array of id/name=>caption for text input fields
*/

function DialogBox(definition,callbackFunction,options){
	this.definition=definition;
	this.callbackFunction=callbackFunction?callbackFunction.replace(/"/g,"'").replace(/'/g,"\'"):''; // IDE WA'
	this.opt=(options)?options:{};
	this.okEnabled=1;
	W.activeDB=this;
}
DialogBox.prototype.show=function (){
	var e,eI=this.opt.extraInput;

	if(this.definition['mask']) wl.mask.show(0,1,false); else wl.mask.show(1);

	var boxDiv=D.createElement("div");
	boxDiv.id='dialogBox';
	boxDiv.className='popup';

	var s=boxDiv.style;
	s.display='none';
	s.width='400px';
	s.marginLeft='-200px';
	s.marginTop='-100px';
	s.top='50%';
	s.left='50%';
	s.zIndex=dgi('maskDiv').style.zIndex+1;

	iconImage='';
	if(this.definition['icon']) iconImage='<img id="dialogBoxIcon" src="'+this.definition['icon']+'" style="vertical-align:middle;margin-right:0.5em">';

	// Title
	iht='';
	if(this.definition['title']) iht+='<div class="popupHeader" id="dialogBoxTitle">'+iconImage+this.definition['title']+'</div>';
	else iht+=iconImage;

	// main caption
	iht+='<div style="width:80%;margin:auto">';
	if(this.definition['text']) iht+='<span id="dialogBoxText">'+this.definition['text']+'</text>';

	iht+='<br><br>';
	// text input
	if(this.definition['input']!==undefined) iht+='<input type="text" class="textInput" style="width:100%" id="dialogBoxInput" value="'+this.definition['input']+'"><br><br>';
	var nb=0; for(e in this.definition['buttons']) nb++;
	if(eI) for(e in eI){
		iht+=eI[e]+'<br><input type="text" class="textInput" style="width:100%" id="'+e+'"><br><br>';
	}

	iht+='</div>';

	iht+='<center>';

	// OK button
	var ecb=this.callbackFunction.replace(/'/g,"\\'"); // "
	if(this.definition['buttons']['ok']) iht+=wl.button.create(this.definition['buttons']['ok'],"dialogBoxButtonPressed('ok','"+ecb+"')",'/gfx/ok16.png','dialogBoxOK')+((nb-->0)?'&nbsp; &nbsp;':'');

	// Cancel button
	if(this.definition['buttons']['cancel']) iht+=wl.button.create(this.definition['buttons']['cancel'],"dialogBoxButtonPressed('cancel','"+ecb+"')",'/gfx/cancel.png','dialogBoxCancel')+((nb-->0)?'&nbsp; &nbsp;':'');;


	iht+='</center>';
	iht+='<br>';

	if(this.definition['check']!=undefined) iht+='<input id="dialogBoxCheck" type="checkbox"'+((this.definition['check'])?' checked="checked"':'')+'>&nbsp;';
	if(this.definition['checkText']) iht+='<span id="dialogBoxCheckText" onclick="dgi(\'dialogBoxCheck\').checked=!dgi(\'dialogBoxCheck\').checked">'+this.definition['checkText']+'</span>';
	// Fill content
	boxDiv.innerHTML=iht;

	//D.body.insertBefore(boxDiv,D.body.firstChild);
	D.body.appendChild(boxDiv);

	// input keystrike monitoring
	if(this.definition['input']!==undefined) wl.setKeycodeListener('dialogBoxInput',this.inputKD)

	if(this.definition['fade']) fade('dialogBox'); else boxDiv.style.display='';
	//var w=(W.winMe)?winMe.getInnerHeight:
	//boxDiv.style.top=((winMe.getInnerHeight()-boxDiv.offsetHeight)/2)+'px';
	//boxDiv.style.left=((winMe.getInnerWidth()-boxDiv.offsetWidth)/2)+'px';
	if(dgi('dialogBoxInput')) dgi('dialogBoxInput').focus();
}
DialogBox.prototype.inputKD=function (kc){
	if(activeDB.opt.inputValid) {
		activeDB.okEnabled=activeDB.opt.inputValid($('dialogBoxInput').value)
		wl.button.enable('dialogBoxOK',activeDB.okEnabled)
	}
	if(kc==27 && dgi('dialogBoxCancel')) eval(dgi('dialogBoxCancel').href)
	if(kc==13 && dgi('dialogBoxOK') && activeDB.okEnabled) eval(dgi('dialogBoxOK').href)
}
DialogBox.prototype.hide=function (){
	dgi('dialogBox').parentNode.removeChild(dgi('dialogBox'));
	wl.mask.hide();
}
DialogBox.prototype.item=function(name){
	if(name=='ok') return dgi('dialogBoxOK');
	if(name=='cancel') return dgi('dialogBoxCancel');
	if(name=='input') return dgi('dialogBoxInput');
	if(name=='check') return dgi('dialogBoxCheck');
	if(name=='title') return dgi('dialogBoxTitle');
	if(name=='text') return dgi('dialogBoxText');
	if(name=='checkText') return dgi('dialogBoxCheckText');
	if(name=='icon') return dgi('dialogBoxIcon');
}


/**
 * Function called when a button is clicked
 * @param button: name of pressed button (ok or cancel)
 * @param callback (string): callback function called with array {'button':button} as parameter. If this function returns anything else thant undefined, dialog is not closed
 */
function dialogBoxButtonPressed(button,callback){
	var result={'button':button},callbackResult,eI,e;
	if(dgi('dialogBoxCheck')) result['check']=dgi('dialogBoxCheck').checked;
	if(dgi('dialogBoxInput')) result['input']=dgi('dialogBoxInput').value;
	if(eI=activeDB.opt.extraInput) for(e in eI) result[e]=dgi(e).value;

	if(callback){
		if(typeof callback=='string') eval('callbackResult='+callback+'(result)');
		else callbackResult=callback(result);
	}
	if(callbackResult==undefined){
		dgi('dialogBox').parentNode.removeChild(dgi('dialogBox'));
		wl.mask.hide();
	}
}



// Async submit comForm
function asyncSubmit(forceSending){
	var dcf=D.comForm;
	data="";
	for(var i=1;i<6;i++) if(dcf['data'+i].value.length>0) data+=((i>1)?"&":"")+"data"+i+"="+encodeURIComponent(dcf['data'+i].value);
	return wl.asr.send(data,dcf.action)
}

// Async submit a form
function asyncSubmitForm(formId,forceSending){
	if(!dgi(formId)) return false;
	var frm=dgi(formId);
	var elt;
	data='';
	for(var o=0;o<frm.getElementsByTagName("input").length;o++) {
		elt=frm.getElementsByTagName("input")[o];
		if(elt.name.length){
			if((elt.type!='radio' && elt.type!='checkbox') || elt.checked){
				if(data.length>0) data+='&';
				data+=elt.name+'='+encodeURIComponent(elt.value);
			}
		}
	}
	for(var o=0;o<frm.getElementsByTagName("select").length;o++) {
		elt=frm.getElementsByTagName("select")[o];
		if(data.length>0) data+='&';
		data+=elt.name+'='+encodeURIComponent(elt.value);

	}
	return wl.asr.send(data,frm.action)
}

// Legacy sendData function
function sendData(d,URL,force){return wl.asr.send(d,URL,0)}















/*********************************************************************************************
 * wl Object
 *********************************************************************************************/
function wJSLib(){
	var me=this;
	this.KDS={};

	this.capt={}; // Array of captions, set by PHP scripts
	this.ico={}; // Array of icons URLs, set by PHP scripts
	this.rVar={}; // Array of RVars
	this.animations={}; // Array of animation id, used to cancel an animation when another animation is set on this object

	/**
	 * Recursive object duplication
	 * @param object srcObj: object to be duplicated
	 * @retur clone
	 */
	this.objectClone=function(srcObj){
		var e,copy={};
		for(e in srcObj){
			if(typeof(srcObj[e])=='object') copy[e]=wl.objectClone(srcObj[e]);
			else copy[e]=srcObj[e];
		}
		return copy;
	}

	/**
	 * Loading icon
	 */
	this.loading={
		'items':{},
		'nbItems':0,
		'inter':0,
		'a':0,
		'icon':'/gfx/loadingS16.png',
		'iconBig':'/gfx/loadingS32.png',
		'set':function(id,big){
			wl.loading.items[id]=$(id);
			$(id).src=wl.loading[(big)?'iconBig':'icon'];
			if(!wl.loading.inter) wl.loading.inter=setInterval(wl.loading.anim,100);
			wl.loading.nbItems++;
		},
		'anim':function(){
			var e,n;
			if(!wl.loading.nbItems) return;
			wl.loading.a=(wl.loading.a-30)%360
			for(e in wl.loading.items) {
				if(!dgi(e)) {wl.loading.stop(e);continue}
				n=wl.loading.items[e];
				n.e.rotate(wl.loading.a)
				if(n.src.indexOf(wl.loading.icon)==-1 && n.src.indexOf(wl.loading.iconBig)==-1) wl.loading.stop(e,n.src);
			}
		},
		'stop':function(id,newIcon){
			for(e in wl.loading.items) if(e==id || !id){
				delete(wl.loading.items[e])
				wl.loading.nbItems--;
				if(!dgi(e)) break;
				$(e).e.rotate(0)
				if(newIcon) $(e).src=newIcon; else $(e).style.display='none';
			}
			if(!wl.loading.nbItems) {
				clearInterval(wl.loading.inter);
				wl.loading.inter=0;
			}
		}
	}

	this.tmp=(function(){lFunc('common',10)})()

	/**
	* MASK
	*/
	this.mask={
		'shown':0,

		/**
		 * @desc Show a full-screen waiting mask, disabling user input
		 * @param bool transparent: true for 100% transparent mask, false for translucid mask. Alpha value if numeric and not 0 and not 1
		 * @param bool doFadeIn: true to include a fade-in animation
		 * @param mixed wCurs: CSS cursor (or false/empty for pointer, true for wait)
		 * @param function onclickF: function called on mask click
		 * @param string innerHTML: mask inner HTML
		 */
		'show':function(transparent,doFadeIn,wCurs,onclickF,innerHTML,options){
			var maskDiv, create, maskDivBg;
			if(!options) options={}
			// Create if inexisting
			if(!dgi('maskDiv')){
				maskDiv=D.createElement("div");
				maskDiv.id='maskDiv';
				create=1;
			}
			// Or retreive
			else maskDiv=dgi('maskDiv');

			// Set inner HTML (use maskDivBg to prevent opacity to be applied to innerHTML)
			maskDiv.innerHTML='<div id="maskDivBg" style="position:absolute;height:100%;width:100%;background:black;left:0px;top:0px"> </div>'+((innerHTML)?'<div style="position:relative;top:50%;text-align:center">'+innerHTML+'</div>':'');

			// Set onclick and oncontextmenu
			if(onclickF) {
				maskDiv.onclick=onclickF;
				maskDiv.oncontextmenu=function(event){onclickF();return wl.mask.righClick(event);}
			}
			else maskDiv.oncontextmenu=wl.mask.righClick;

			with(maskDiv.style){
				// Hide
				display='none';	position='absolute';
				// Cursor
				if(!wCurs) curor='pointer';
				else if(wCurs===true) cursor='wait';
				else cursor=wCurs;
				// Position
				top=left=margin=padding='0';
				width=D.body.scrollWidth+'px';
				height=Math.max(D.body.scrollHeight,(W.winMe)?winMe.getInnerHeight():0)+'px';
				zIndex=Math.max(99998,(W.dd && dd.z)?dd.z*1+1:0);
			}
			if(create) {
				try{D.body.insertBefore(maskDiv,D.body.firstChild)} catch(e){alert('JS Error creating node. Try disabling DivX Plugin')}
			}

			maskDivBg=dgi('maskDivBg')

			// Color
			maskDivBg.style.background=(options.background)?options.background:'black';

			// Opacity
			op=((transparent)?((isNaN(transparent)||transparent==0||transparent==1)?0.01:transparent):0.2);

			if(doFadeIn) wl.anim({'item':maskDivBg,'duration':300,'function':function(p,anim){if(p==0) dgi('maskDiv').style.display='';return {'opacity':p*op}}});
			else {
				setAlpha(maskDivBg,op);
				maskDiv.style.display='';
			}
			//if(doFadeIn) fade(maskDiv,0,0.2,3); else maskDiv.style.display='';
			wl.mask.shown=1;
		},

		/**
		 * @desc hide mask
		 * @param bool doFadeOut: true to anim
		 */
		'hide':function(doFadeOut){
			wl.mask.shown=0;
			if(!dgi('maskDiv')) return;
			if(doFadeOut) fade(dgi('maskDiv'),0.2,0,3,'removeNode(dgi("maskDiv"))'); else removeNode(dgi('maskDiv'));
		},
		/**
		 * Show / hide mask: UI IE refresh bug WA
		 */
		'blink':function(){
			wl.mask.show();
			setTimeout(wl.mask.hide,10)
		},
		'righClick':function(e){
			if(!e) e=event;
			if(e.stopPropagation) e.stopPropagation(); else	e.cancelBubble=true;
			return false;
		},
		// Move item above mask
		'moveAbove':function(n){
			if(!wl.mask.node()) return;
			if(n.id && W.dd && dd.elements[n.id]) dd.elements[n.id].setZ(Math.max(dd.z,wl.mask.node().style.zIndex*1+1))
			else n.style.zIndex=wl.mask.node().style.zIndex*1+1;
		},
		'node':function(){return dgi('maskDiv')}
	}




	/**
	 * Sync Post data without a pre-created form
	 */
	this.postData=function (data,URL){
		var f=D.createElement('FORM'), h='';
		if(data) for(var e in data) h+='<input type="text" name="'+e+'" value="'+data[e]+'">';
		f.style.display="none";
		f.enctype="multipart/form-data";
		f.method='POST';
		if(URL) f.target=URL;
		f.innerHTML=h;
		D.body.appendChild(f);
		f.submit();
	}

	/**
	 * Go to URL
	 * String URL: new URL or ?a=b to go to same URL with new GET parameters, or &a=b to go to same URL keeping current GET parameters
	 */
	this.goURL=function(URL){
		var tURL=D.location.href;
		// If URL not provided, set current URL (remove hash as it prevents page from reloading)
		if(!URL){URL=tURL;if(URL.indexOf('#')>0) URL=URL.substr(0,URL.indexOf('#'));}
		// If only GET parameters passed, reuse current URL (but remove previous GET parameters)
		else if(URL.substr(0,1)=='?'){
			if(tURL.indexOf('?')>0) tURL=tURL.substr(0,tURL.indexOf('?'));
			URL=tURL+URL;
		}
		// If only GET parameters passed, reuse current URL (but remove previous GET parameters)
		else if(URL.substr(0,1)=='&'){
			URL=(tURL.indexOf('?')>0)?tURL+URL:tURL+'?'+URL.substr(1);
		}

		D.location.href=wl.insertSessionIDInURL(URL);
	}

	/**
	 * Pack an associative array into an URL-proof string
	 */
	this.arrayPack=function(o){
		var c=function(t){return (W.appType=='Qt')?t:encodeURIComponent(t)}
		if(typeof(o)!='object') return '"'+c(o)+'"';
		var s='{',e,nb=0;
		for(e in o) {
			s+=((nb++==0)?'':',')+'"'+c(e)+'"'+c(':');
			if(typeof(o[e])=='object') s+=this.arrayPack(o[e]);
			else s+='"'+c(o[e].toString().replace(/\"/g,'\\"'))+'"';
		}
		return s+'}';
	}


	/**
	 * fade item's opacity to given alpha value
	 * i: item or item's id
	 * a (0-1): target alpha
	 * nbSteps: number of steps to reach target alpha
	 */
	this.fadeItems={}
	this.fadeTo=function (i,a,nbSteps){
		if(typeof(i)=='object'){if(i.id) i=i.id; else i=i.id='id'+Math.floor(999999*Math.random());}
		if(wl.fadeItems[i]===a) return;
		var n=dgi(i),ca=n.style.opacity;
		if(n.style.display=='none'||n.style.visibility=='hidden') ca=0;
		else if(ca===undefined || ca==='') {
			if(ca=n.style.filter) {
				ca=(ca.substring(ca.indexOf('ty=')+3,ca.indexOf(')')))/100;
			}
			else ca=1;
		}
		if(nbSteps==undefined) nbSteps=Math.floor(Math.abs(ca-a)*10);
		wl.fadeItems[i]=a;
		fade(i,ca*1.0,a*1.0,nbSteps)
	}

	/**
	 * Animation function
	 * @param p: animation parameters
	 *			.duration: animation duration, in ms (default 500ms)
	 *			.item: dom node to animate
	 *			or .items: array of {'item':, 'function':} (if .items is passed, .function parameter is only passed in items array)
	 *			.function: animation function, taking as 3 parameters animation step (0-1), animated node, animation data, and returning an associative array of style properties applyed to node.
	 *	 			Note: parameters can be passed to animation function by passing extra parameters to this (anim) function
	 *			.callbackStep: function called at every step, passing animation data as parameter. May be a string or a function
	 *			.callbackComplete: function called when anim completed, passing animation data as parameter
	 *			.reverse: set to true to animate in reverse side
	 *			.single: set to true to cancel animation if another animation on this node is started
	 */
	this.anim=function(p){
		var prop,e,i,it,s,init,c;
		if(p.stopped) return; // Animation cancelled: abort

		p.time=wl.chrono.microtime();
		// Init animation
		if(!p.timeStart) {
			this.stopped=0;
			p.timeStart=p.time;
			p.stop=function(){this.stopped=1}
		}

		p.dt=(p.prevTime!==undefined)?p.time-p.prevTime:0;
		p.prevTime=p.time;
		if(!p.duration) p.duration=500;
		p.step=Math.min(1,(p.time-p.timeStart)/p.duration);
		if(p.reverse) p.step=1-p.step;

		// Single item in animation
		if(p.item) {
			// Single-animation on a node
			if(p.single){
				// Initialise single animation on this node
				if(!p.animId){
					if(!p.item.id) p.item.id='rnd'+Math.random();
					wl.animations[p.item.id]=p.animId=Math.random();
				}
				// If another anim has started for this item, abort
				if(wl.animations[p.item.id]!=p.animId) return;
			}

			prop=p['function'](p.step,p)
			s=p.item.style;
			for(e in prop) {
				if(e=='opacity') setAlpha(p.item,prop[e]);
				else if((e=='width'||e=='height'||e=='left'||e=='top') && !isNaN(prop[e])) s[e]=prop[e]+'px';
				else s[e]=prop[e];
			}
		}

		// Multiple items in animation
		if(p.items){
			for(i=0;i<p.items.length;i++){
				it=p.items[i];
				s=it.item.style;
				prop=it['function'](p.step,it)
				for(e in prop) {
					if(e=='opacity') setAlpha(it,prop[e]); else	s[e]=prop[e];
				}
			}
		}

		p.completed=(p.reverse && p.step<=0) || (!p.reverse && p.step>=1);

		// Call animation step callback if set
		if(c=p.callbackStep) {
			if((typeof c)=='string'){
				if(c.indexOf('(')>=0) eval(c); else eval(c)(p);
			}
			else c(p);
		}

		// Timeout to next animation step
		if(!p.completed) setTimeout(function(){wl.anim(p)},1);

		// Anim completed
		else {
			// Call callback if set
			if(c=p.callbackComplete) {
				if((typeof c)=='string'){
					if(c.indexOf('(')>0) eval(c); else eval(c)(p);
				}
				else c(p);
			}
		}
			if(W.phpBrowser=='ie') wl.fixIELayout()

		return p;
	}

	/**
	 * Unfold animation profile function (S - type profile)
	 * @param p: unfold percentage (0-1)
	 */
	this.animFunctionUnfold0=function(p){
		var e=7; p=Math.pow(p,1);
		if(p<0.5) return Math.pow(p*2,e)/2;
		return 1-Math.pow(2-p*2,e)/2;
	}

	/**
	 * Common unfold animation profile function (bounce)
	 * @param p: unfold percentage (0-1)
	 */
	this.animFunctionUnfold1=function(p){
		if(p<0.5) w=Math.min(1,Math.pow(p*2,2)); else w=1-Math.abs(Math.sin(Math.PI*(p-0.5)*2)*Math.exp(-4*p));
		return w;
	}

	/**
	 * Elastic unfold animation profile function
	 * @param p: unfold percentage (0-1)
	 */
	this.animFunctionUnfold2=function(p,anim){
		var i,x=anim.animX,v=anim.animV,dt=2,nx,nb;
		var m=1,r1=8,r2=10,l=600;

		// Init speed & position
		if(x===undefined){
			v=0; x=1;
			// Special: windows animation: integrate animation amplitude into elastic computing
			if(anim.extraParams){
				x=Math.abs(anim.extraParams.destW-anim.extraParams.startW)/1000;
				if(isNaN(x)) x=1;
			}
		}

		nb=Math.ceil(anim.dt/dt);
		dt/=1000;

		// Compute new speed & position
		if(p==1) x=0;
		else for(i=0;i<nb;i++){
			v+=(-x*l-r1*v-r2*v*Math.abs(v))*dt;
			x+=v*dt
		}

		// Store speed & position
		anim.animX=x;	anim.animV=v;

		return 1-x;
	}

	/**
	 * Common unfold animation profile function (small bounce)
	 * @param p: unfold percentage (0-1)
	 */
	this.animFunctionFold1=function(p,anim){
		if(p<0.5) w=1-Math.min(1,Math.pow(2*p,2)); else w=-0.7*(2*p*p-3*p+1);
		return w;
	}

	/**
	 * Negative exponential unfold animation profile function
	 * @param p: unfold percentage (0->1)
	 */
	this.animFunctionFold2=function(p,anim){
		var f=-9,w=(Math.exp(f*p) - Math.exp(f))/(1-Math.exp(f));
		if(p==1) w=0;
		return Math.max(w,0);
	}

	/**
	 * Common unfold animation profile function (bounce)
	 * @param p: unfold percentage (0-1)
	 */
	this.animFunctionUnfold3=function(p){
		return (p<0.5)?x=2*p*p:x=1-2*(1-p)*(1-p);
	}

	/**
	 * Elastic unfold animation profile function
	 * @param p: unfold percentage (0-1)
	 */
	this.animFunctionFold3=function(p,anim){
		return (p<0.5)?x=1-2*p*p:x=2*(1-p)*(1-p);
	}



	/**
	* collapse/unfold nodes
	*/
	this.COLLAPSE_DURATION=250; // Time of a fold / unfold animation (ms)
	this.nodeCollapseInProgress={}; // Assoc. array of collapse animations in progress

	// Hide / show draggable items contained into collapasable frame
	this.toggleContainedDragItems=function(item,action){
		var o,i;
		if(!W.dd || !dd.elements || !dd.elements.length) return;
		for(i=0;i<item.childNodes.length;i++){
			if(item.childNodes[i].attributes && item.childNodes[i].attributes["id"]) {
				for(o=0;o<dd.elements.length;o++){
					if(dd.elements[o].name==item.childNodes[i].attributes["id"].value) {
						if(action=='hide') dd.elements[o].hide(); else dd.elements[o].show();
					}
				}
			}
			if(item.childNodes[i].hasChildNodes) wl.toggleContainedDragItems(item.childNodes[i],action);
		}
	}

	// True if frame is collapsed
	this.isCollapsed=function(id){
		var s=dgi(id).style;
		return (s.display=='none' || s.height=="0px" || s.height=="1px")
	}


	/**
	 * Animation function for vertical fold/unfold anims
	 * @param p: anim percentage 0-1
	 * @param n: animated node
	 * @param anim: anim parameters (see wl.anim function). Includes tHeight var indicating block unfolded height
	 */
	this.nodeCollapseAnim=function(p,anim){
		if(anim.callbackStep) eval(anim.callbackStep+'("'+anim.item.id+'","anim")');
		var e,p=((anim.reverse)?wl.animFunctionFold3(1-p):wl.animFunctionUnfold3(p,anim)),h=Math.floor(anim.tHeight*p);
		if(phpBrowser=='ie' && h==0) h=1;// 0px height causes problems under IE
		var ret={'height':h+'px'}
		if(anim.tMP) for(e in anim.tMP) ret[e]=Math.floor(p*anim.tMP[e])+'px';
		return ret
	}


	/**
	 * Toggle collapse state of a node, and animate
	 * @param id: id of node
	 * @param phpVarName: if set, name of php var that must be async updated to set to true if collapsed, false if unfolded
	 * @param jsCallbackFunctionName: name of function called on completition
	 */
	this.nodeCollapseToggle=function(id, phpVarName, jsCallbackFunctionName){
		if(wl.nodeCollapseInProgress[id]) return;
		wl.nodeCollapseInProgress[id]=1;

		if(wl.isCollapsed(id))
			wl.nodeCollapseUnfold(id, phpVarName, jsCallbackFunctionName)
		else
			wl.nodeCollapseFold(id, phpVarName, jsCallbackFunctionName)
	}

	/**
	 * Unfold a node
	 * See nodeCollapseToggle for parameters
	 */
	this.nodeCollapseUnfold=function(id, phpVarName, jsCallbackFunction){
		var bid=0,s,n,i,tHeight,en,tMP={},mon=['marginTop','marginBottom','paddingTop','paddingBottom'],val;
		if(!(n=dgi(id))) return;
		s=n.style;en=$(n).e;

		// transparently unfold div to compute inner height, padding & margin
		s.visibility='hidden';s.position='absolute';s.height='';s.display='block';
		tHeight=n.offsetHeight;

		// Store unfolded values for padding & margin
		for(i=0;i<mon.length;i++) {if(val=en.getStyle(mon[i])) tMP[mon[i]]=val.replace(/px/,'');}
		s.overflow='hidden';s.height='1px';s.position='static';s.visibility='visible';

		// Anim start callback (backward compatibility)
		if(jsCallbackFunction && typeof jsCallbackFunction=='string') eval(jsCallbackFunction+'("'+id+'","startUnfold")');

		// Change toggle button icon
		if(dgi(id+'BtMinus')) bid=id; else if(dgi(dgi(id).parentNode.id+'BtMinus')) bid=dgi(id).parentNode.id;
		if(bid) {dgi(bid+'BtMinus').style.display='inline';	dgi(bid+'BtPlus').style.display='none';}

		// Hide / show draggable items contained into collapasable frame
		wl.toggleContainedDragItems(n,'show');

		// Update server-side var
		if(phpVarName) sendData(phpVarName+"=true");

		// Start animation
		wl.anim({'item':n,
				'duration':wl.COLLAPSE_DURATION,
				'function':wl.nodeCollapseAnim,
				'tHeight':tHeight,
				'tMP':tMP,
				'callbackStep':jsCallbackFunction,
				'callbackComplete':function(anim){
					s=anim.item.style; s.position=''; s.overflow='';
					if(jsCallbackFunction) eval(jsCallbackFunction+'("'+id+'","doneUnfold")');
					if(W.onCollapseFunction) onCollapseFunction(id,"doneUnfold");
					if(W.dd) dd.recalc();
					wl.nodeCollapseInProgress[id]=0;
				}
			});
		}

	/**
	 * Fold a node
	 * See nodeCollapseToggle for parameters
	 */
	this.nodeCollapseFold=function(id, phpVarName, jsCallbackFunction){
		var s,n,i,tHeight,en,tMP={},mon=['marginTop','marginBottom','paddingTop','paddingBottom'],val,bid;

		if(!(n=dgi(id))) return;
		s=n.style;en=$(n).e;
		// Store unfolded height & margins & paddings
		tHeight=n.offsetHeight;
		for(i=0;i<mon.length;i++) {if(val=en.getStyle(mon[i])) tMP[mon[i]]=val.replace(/px/,'')}
		s.overflow='hidden';

		// Anim start callback (backward compatibility)
		if(jsCallbackFunction && typeof jsCallbackFunction=='string') eval(jsCallbackFunction+'("'+id+'","startFold")');

		// Change toggle button icon
		if(dgi(id+'BtMinus')) bid=id; else if(dgi(dgi(id).parentNode.id+'BtMinus')) bid=dgi(id).parentNode.id;
		if(bid) {dgi(bid+'BtMinus').style.display='none';	dgi(bid+'BtPlus').style.display='inline';}

		// Update server-side var
		if(phpVarName) sendData(phpVarName+"=false");

		// Start animation
		wl.anim({'item':dgi(id),
				'duration':wl.COLLAPSE_DURATION,
				'function':wl.nodeCollapseAnim,
				'reverse':1,
				'tHeight':tHeight,
				'tMP':tMP,
				'callbackStep':jsCallbackFunction,
				'callbackComplete':function(anim){
					s=anim.item.style;s.height=((phpBrowser=='ie')?1:0)+'px';s.visibility="hidden"
					wl.toggleContainedDragItems(dgi(id),'hide');
					if(jsCallbackFunction) eval(jsCallbackFunction+'("'+id+'","doneFold")');
					if(W.onCollapseFunction) onCollapseFunction(id,"doneFold");
					if(W.dd) dd.recalc();
					wl.nodeCollapseInProgress[id]=0;
				}
			})
	}

	this.tmp=(function(){lFunc('common',10)})()


	/**
	* Simple event subscribe / send system: allow objects/functions in other frames to be informed of modifications.
	* Mainly used in UI to inform other frames that a resource, user, direct link... has been created/deleted/modified
	*
	* emit event: emit an event with a main type: "resource", "user",... and a property array.
	* event will be recursively "broadcasted" to this frame, to iframes and to upper frames
	*
	* subscribe: subscribe to an event with a given type
	*/

	this.SimpleEvent=function (){
		this.subscribed=[];

		/**
		 * Subscribe to an event
		 * String type: event type
		 * function func: function called on event reception, with event's parameters + type as input parameter
		 */
		this.subscribe=function(type,func){wl.event.subscribed.push({'type':type,'func':func})}

		/**
		 * Emit an event
		 * String type: event type
		 * Assoc array args: event's arguments
		 * String direction: event propagation direction: empty=both, "up" (from lower frame to upper frame), "down" (from upper frame to lower frames), "no" (to local frame, without propagation)
		 */
		this.emit=function(type,args,direction){
			args.type=type;
			if(!direction) wl.event.receive(args); // Emit to this frame

			if(direction!="down") try{if(parent!=W) parent.wl.event.receive(args,"up")} catch(e){} // Propagate upward

			if(direction!="up") {
				var iF=D.getElementsByTagName("IFRAME"),i;
				for(i=0;i<iF.length;i++) try{frames[iF[i].name].wl.event.receive(args,"down")} catch(e){} // Propagate downward
			}
		}

		/**
		 * Receive an event from this frame or another frame
		 * Assoc array args: event's parameters including event type
		 * string direction: "up" or "down" to propagate event upward or downward, or empty not to propagate
		 */
		this.receive=function(args,direction){
			var i,s=wl.event.subscribed;

			for(i=0;i<s.length;i++) if(s[i].type==args.type) s[i].func(args);
			if(direction) wl.event.emit(args.type, args, direction);
		}
	}

	this.event=new this.SimpleEvent();





	/**
	* Scroll divs
	*/
	function asd(){this.scrolling=0;this.divList=[]}
	asd.prototype.add=function (item){
		this.divList.push(item);
	}
	asd.prototype.check=function (){
		if(!dd.obj) return;
		var it;
		for(var i=0;i<this.divList.length;i++){
			it=this.divList[i];
			if(dd.obj.y>actualOffsetTop(it) && dd.obj.y<actualOffsetTop(it)+2*dd.obj.h && dd.obj.x>actualOffsetLeft(it) && dd.obj.x+dd.obj.w<actualOffsetRight(it)) this.scroll("up",it);
			if(dd.obj.y>actualOffsetBottom(it)-2*dd.obj.h && dd.obj.y+dd.obj.h<actualOffsetBottom(it) && dd.obj.x>actualOffsetLeft(it) && dd.obj.x+dd.obj.w<actualOffsetRight(it)) this.scroll("down",it);
		}
	}
	asd.prototype.scroll=function (dir,item){
		if(this.scrolling) return;
		this.scrolling=1;
		if(dir=='up') item.scrollTop-=20; else item.scrollTop+=20;
		W.setTimeout('wl.autoScrollDivs.done()',10);
	}
	asd.prototype.done=function (){this.scrolling=0;this.check()}

	this.autoScrollDivs=new asd();

	/**
	* Debug functions
	*/
	this.dbgw=function(txt,lineBreak){if(parent && parent.winDebug) parent.winDebug(txt,lineBreak); else winDebug(txt,lineBreak)}
	this.dbgServer=function(txt,toFile){sendData('toFile='+toFile+'&dbgServer='+encodeURIComponent(txt),'/servDbg.php')}
	//	Chrono
	function chrono(){this.v=0};
	chrono.prototype.microtime=function (){return (new Date()).getTime()}
	chrono.prototype.time=function (){return (Math.floor((new Date()).getTime())/1000)}
	chrono.prototype.start=function (){this.chrono=this.microtime()}
	chrono.prototype.get=function (){return this.microtime()-this.chrono}
	this.chrono=new chrono();

	/**
	* Misc functions
	*/

	// Insert WSESSID into GET parameters of URL. Used to transmit session id in embedded webbrowser control as cookies are not reliable
	this.insertSessionIDInURL=function(url){
		if(!W.WSESSID||url.indexOf('WSESSID')>0) return url;
		return url+((url.indexOf('?')!=-1)?'&':'?')+'WSESSID='+W.WSESSID;
	}

	// Return link to resized version of an image located into /gfx
	this.resizedGfx=function(src,w,h){return '/img/w.'+w+'/h.'+h+'/rot.0/resId.0/file.'+src}

	// Return zoom factor for webkit mobile devices
	this.viewportZoom=function(){return Math.abs(W.orientation)==90?((bBrowser=='iPhone')?480:1024)/W.innerWidth:((bBrowser=='iPhone')?320:768)/W.innerWidth}

	// Fix an issue with non-redrawn relative-positioned items
	this.fixIELayout=function(){var c=$(D.body).e.className(); c.add('fixLayout'); c.remove('fixLayout')}

	// Check if an email address is valid
	this.isValidMail=function(mail){
		return (new RegExp('^[a-z0-9]+([_|\.|-]{1}[a-z0-9]+)*@[a-z0-9]+([_|\.|-]{1}[a-z0-9]+)*[\.]{1}[a-z]{2,6}$', 'i')).test(mail);
	}

	/**
	 * Open a cross domain popup (not on current host), an monitor response that will be passed behind a hash in current window's url
	 * @param string url: url of popup
	 * @param string name: name of popup window
	 * @param array options: array of options (width, height)
	 * @param funtion callback: function called with cross domain popup result
	 */
	this.crossDomainPopup=function (url,name,options,callback){
		var wOpt='',l=D.location; if(l.hash) l.hash='';
		// Turn options into a GET string for in-app popup or into a comma separated list for window.open
		for (e in options) wOpt+=((isApp)?'&':',')+e+'='+options[e];
		if(wOpt.substr(0,1)==',') wOpt=wOpt.substr(1);

		// In app popup
		if(isApp) return wl.UIWebPopup('/local/uiPopupRedirect.php?url='+encodeURIComponent(url)+wOpt,callback);

		// Regular popup
		if(!wl.crossDomainPopupI) wl.crossDomainPopupI=W.setInterval(wl.crossDomainPopupMonitor,50);
		wl.crossDomainPopupC=callback;
		W.open(url,name,wOpt);
	}
	this.crossDomainPopupI=0; this.crossDomainPopupC=0;
	this.crossDomainPopupMonitor=function (){
		var l=D.location,res=l.hash;
		if(res && res.length>1){
			wl.crossDomainPopupC(res);
			//l.hash='';
			W.clearInterval(wl.crossDomainPopupI);
		}
	}

	/**
	 * Open a popup window, using application web popup, win popup or regular browser popup, depending on context
	 * @param url: url of popup
	 * @param title: popup's title
	 * @param options: array of options (id for window id, see window.open for other parameters
	 *			(only width & height are considered for win popup))
	 */
	this.popup=function (url,title,options){
		var wOpt='',nw;
		if(!options) options={};
		// Turn options into a GET string for in-app popup or into a comma separated list for window.open
		for (e in options) wOpt+=((isApp)?'&':',')+e+'='+options[e];
		if(wOpt.substr(0,1)==',') wOpt=wOpt.substr(1);
		if(!options.id) options.id='W'+Math.random();

		// In app popup
		if(isApp) return wl.UIWebPopup('/local/uiPopupRedirect.php?url='+encodeURIComponent(url)+wOpt);

		// win popup in main frame
		if(noPopup && (W.isMainFrame || parent && parent.isMainFrame)) {
			var base=(W.isMainFrame)?W:parent;
			base.winOpenLocation(url,options.id,title,(W.winMe)?winMe.winMyId:'');
			if(!options.width) options.width=0;if(!options.height) options.height=0;
			nw=base.win(options.id);
			if(options.width||options.height) nw.resizeInnerTo(options.width,options.height);
			nw.center();
			nw.show();
			if(W.winMe) nw.setOpenerId(winMe.id)
		}
		// Regular popup
		else{
			nw=W.open(url,title,wOpt);
			nw.moveTo(screen.width/2-nw.outerWidth/2,screen.height/2-nw.outerHeight/2)
		}
		return nw;
	}

	// simple cookie management
	this.cookie={
		set:function(name,value,minutes,secure){
			var exp="",d=new Date();
			if (minutes) {
				var a=d.toGMTString();
				d.setTime(d.getTime()+(minutes*60000))
				expires="; expires="+d.toGMTString();
			}
			D.cookie=name+"="+escape(value)+';Path=/'+((secure)?";secure":"")
		},
		get:function(name){
			var c,i,l=D.cookie.split(';');
			for(i=0;i<l.length;i++) {
				c=l[i].trim();
				if(c.indexOf(name+'=') == 0) return c.substring(name.length+1,c.length);
			}
		}
	}

	// Disconnect user
	this.disconnect=function(){top.location.href="/index.php"}

	// Display a QR Code to url (b64 encoded), centered on node
	this.qrCodeShow=function(url,node){
		// Open in top window if possible
		try{if(W!=top && top.wl) return top.wl.qrCodeShow(url,0)} catch(e){alert(e)}

		var n,l,t;
		wl.mask.show(0,1,false,function(){$('qrCodeNode').click()});
		if(node) node=$(node);
		if(!dgi('qrCodeNode'))	n=$('qrCodeNode').e.create('IMG');
		with(n=$('qrCodeNode')){
			onclick=function(){$(this).e.remove();wl.mask.hide()}
			src='/ext/qrCode.php?url='+url;
			if(node) l=node.e.actualOffsetLeft()+node.offsetWidth/2; else l=dd.getWndW()/2;
			l=Math.max(10,l-n.offsetWidth/2);
			if(W.dd) l=Math.min(l,dd.getWndW()-n.offsetWidth-10);
			style.left=l+'px';
			if(node) t=node.e.actualOffsetTop()+node.offsetHeight/2; else t=dd.getWndH()/2;
			t=Math.max(10,t-n.offsetHeight/2);
			if(W.dd) t=Math.min(t,dd.getWndH()-n.offsetHeight-10);
			style.top=t+'px';
			style.cursor='pointer';
		}
		wl.mask.moveAbove(n);
	}

	/**
	 * alert replacement
	 * @param text: text to display
	 */
	this.msg=function(text){
		if(appType=='Qt' && isApp) text=text.replace(/"/g,"'");//'
		alert(text);
	}

	/**
	 * prompt replacement
	 * @param text: text to display
	 */
	this.prompt=function(text){
		if(appType=='Qt' && isApp) text=text.replace(/"/g,"'");//'
		return prompt(text);
	}

	/**
	 * prompt replacement
	 * @param text: text to display
	 */
	this.confirm=function(text){
		if(appType=='Qt' && isApp) text=text.replace(/"/g,"'");//'
		return confirm(text);
	}

	// Temporarily re-enable context menu in interface
	/*
	this.contextMenuEnableTemp=function(){
		D.oncontextmenu=function(e){return true};
		setTimeout(function(){D.oncontextmenu=function(e){return false}},1000);
		return true;
	}
	*/

	/*
	 * Animations: remove actual processing time to animation timeout value
	 */
	this.adaptedTimeoutValueStart=function(){this.aTVSC=wl.chrono.microtime()}
	this.adaptedTimeoutValue=function(t){return Math.max(0,t-wl.chrono.microtime()+this.aTVSC)}

	// Get flash player from id
	this.getFlashPlayer=function (id){
		if(navigator.appName.indexOf("Microsoft") != -1) return window[id]; else return document[id];
	}

	// Return flash player version or 0 if flash not detected
	this.flashVersion=function(){
		var i=0, v=0, p, t='application/x-shockwave-flash',ax='ShockwaveFlash.ShockwaveFlash',li=['.7','.6',''];
		try{v=navigator.mimeTypes[t].enabledPlugin.description}
		catch(e){
			for(;i<li.length;i++){try{if((v=(new ActiveXObject(ax+li[i])).GetVariable("$version"))) break} catch(e){}}
		}
		if(v==0) return 0;
		v=v.replace(/[a-zA-Z ]/g,'').replace(/,/g,'.');
		if((p=v.indexOf('.'))>0 && (p=v.indexOf('.',p+1))>0) v=v.substr(0,p);
		return 1.0*v;
	}
	this.hasFlash=function(){return this.flashVersion!=0}

	// Return true if html5 video tag is supported. If codec is set (in "webm", "ogv", "h264"), return true if html5 video tag and codec are supported
	this.html5Video=function(codec){
		var v=D.createElement('video');
		if(!v.canPlayType) return 0;
		if(!codec) return 1;
		if(codec=="webm") return ((v.canPlayType('video/webm; codecs="vp8, vorbis"').replace(/no/, ''))?1:0)
		if(codec=="ogv") return ((v.canPlayType('video/ogg; codecs="theora, vorbis"').replace(/no/, ''))?1:0)
		if(codec=="h264") return ((v.canPlayType('video/mp4; codecs="avc1.42E01E, mp4a.40.2"').replace(/no/, ''))?1:0)
	}

	// Return true if html5 video tag is supported. If codec is set (in "webm", "ogv", "h264"), return true if html5 video tag and codec are supported
	this.html5Audio=function(codec){
		var v=D.createElement('audio');
		if(!v.canPlayType) return 0;
		if(!codec) return 1;
		if(codec=="mp3") return ((v.canPlayType('audio/mpeg; codecs="mp3"').replace(/no/, ''))?1:0);
		if(codec=="ogv") return ((v.canPlayType('audio/ogg; codecs="vorbis"').replace(/no/, ''))?1:0);
	}

	/**
	 * Detect if navigator has named plugin
	 * @param name: all-browsers plugin name
	 * @param ieName: IE plugin name
	 */
	this.hasPlugin=function(name,ieName){
		var pl=navigator.plugins;

		if (pl && pl.length) {
		    for (i=0; i < pl.length; i++ ) if (pl[i].name.toLowerCase().indexOf(name.toLowerCase()) >= 0) return 1;
		}
		else if (W.ActiveXObject) {
			try{if(new ActiveXObject(ieName)) return 1} catch(e){}
		}
		return 0;
	}

	/**
	 * Set client capabilities: resolution, html5 audio/video support, flash support...
	 * Result is posted to index.php for server-side storage. Note: if any test is added to this function, setClientCapabilities() in index.php must be updated to reflect the new value
	 */
	this.setClientCapabilities=function(){
		var cap={'setClientCapabilities':1};

		cap.flash=wl.flashVersion();
		cap.html5VideoWebm=wl.html5Video('webm');
		cap.html5VideoOgv=wl.html5Video('ogv');
		cap.html5VideoH264=wl.html5Video('h264');

		cap.html5AudioMp3=wl.html5Audio('mp3');
		cap.html5AudioOgv=wl.html5Audio('ogv');

		cap.qt=wl.hasPlugin('QuickTime','QuickTime.QuickTime');
		cap.vlc=wl.hasPlugin('VLC','VideoLAN.VLCPlugin.2');
		cap.divx=wl.hasPlugin('DivX','npdivx.DivXBrowserPlugin.1');
		cap.wmp=wl.hasPlugin('Windows Media Player','MediaPlayer.MediaPlayer.1');

		//for(i in cap) D.write(i+'='+cap[i]+'<br>');
		wl.asr.send(cap,'/index.php');
	}

	/**
	 * Return current URL without URI
	 */
	this.hostPortURL=function(){
		var h=D.location.href;
		return h.substr(0,h.indexOf('/',9));
	}

	this.tmp=(function(){lFunc('common',10)})()

	/**
	 * Cross-browser (ie. works in IE) setTimeout function
	 */
	this.setTimeout=function(){
		var a = arguments;
		if(a.length<3) return setTimeout(a[0],a[1]);
		return setTimeout(function(){a[0](a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9])},a[1]);
	}

	/**
	 * Cross-browser (ie. works in IE) setTimeout function
	 */
	this.setInterval=function(){
		var a = arguments;
		if(a.length<3) return setInterval(a[0],a[1]);
		return setInterval(function(){a[0](a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9])},a[1]);
	}

	/**
	 * Shorter version for Math.random();
	 */
	this.rnd=function(min,max){
		var r=Math.random();
		if(min==undefined) return r;
		if(max!=undefined) return min+(max-min)*r;
		return min*r;
	}

	// Dynamic script inclusion
	this.includeScript=function(sName,debug){
		var script=D.createElement('script'),head=D.getElementsByTagName('head')[0];
		script.setAttribute('src','/js/'+sName+((sName.indexOf('?')!=-1)?'&':'?')+'v='+appVersion+((debug)?'&rnd='+Math.random():''));
		script.setAttribute('type','text/javascript');
		head.appendChild(script);
		return script;
	}

	/**
	 * Return next item in an associative array
	 * @param arr: assoc array
	 * @param id: array key
	 */
	this.arrayNext=function(arr,id){
		var e,f=0;
		for(e in arr) {
			if(e==id) f=1;
			else if(f) return arr[e];
		}
	}

	/**
	 * Return previous item in an associative array
	 * @param arr: assoc array
	 * @param id: array key
	 */
	this.arrayPrev=function(arr,id){
		var e,f;
		for(e in arr) {
			if(e==id) return f;
			f=arr[e];
		}
	}

	// Return B/KB/MB/GB formated size
	this.formatedSize=function(s){
		if(s<1024) return s+' B';
		if((s/=1024)<1024) return Math.ceil(s)+' KB';
		if((s/=1024)<1024) return (Math.ceil(100*s)/100)+' MB';
		return (Math.ceil(1000*s/1024)/1000)+' GB';
	}

	// Return link to 16x16 icon for a given file
	this.fileExtIconSrc=function(f){return '/gfx/ext/ico'+f.substr(f.lastIndexOf('.'))}

	// Add a function calling callback on key pressed, with keycode value as argument, pass null as callback to remove
	// evt: 'onkeyup' or 'onkeydown'
	this.setKeycodeListener=function (n,callback,evt){
		if(typeof n=='string') n=dgi(n);
		if(!n) return;
		if(evt='onkeyup'){
			n.onkeyup=n.onkeydown;
			n.onkeyup=(callback)?wl.eventToKeycode:null;
		}
		else{
			n.onkeydowntmp=n.onkeydown;
			n.onkeydown=(callback)?wl.eventToKeycode:null;
		}
		n.keycodeListenerCallback=callback;
	}
	this.removeKeycodeListener=function (item){
		item.onkeydown=(item.onkeydowntmp)?item.onkeydowntmp:function(e){};
	}
	this.eventToKeycode=function(e){
		var kc=wl.eventKC(e),srcT,t;

		if(e){ // Gecko
			t=e.target
		}
		else if(W.event){ // IE & Opera
			t=W.event.srcElement
			e=W.event
		}
		srcT=t;
		while(!t.keycodeListenerCallback && t.parentNode && t!=t.parentNode) t=t.parentNode
		t.keycodeListenerCallback(kc,srcT,e)
	}

	// Call a function when a key designated by it's keycode is pressed
	this.assignKey=function(kc,callback){connect(W,'keyup',function(ekc){ekc=wl.eventKC(ekc);if(ekc==kc) callback()})}

	// Return keycode from event
	this.eventKC=function(e){
		return (e&&e.which)?e.which:(W.event?event.keyCode:0)
	}
	this.eventTarget=function(e){return (e&&e.target)?e.target:(W.event?event.srcElement:0);}

	// Key Down handler
	this.KDHandler=function(e){
		kc=wl.eventKC(e);
		var t=(e.target)?e.target:e.srcElement;
		for(i in wl.KDS[t])
			if(i==kc){
				eval(wl.KDS[t][i])
			}
	}

	this.KDHandlerD=function(e){
		kc=wl.eventKC(e);
		for(var i in wl.KDS[D]){
			if(i==kc) eval(wl.KDS[D][i])
		}
	}

	this.setKDHandler=function (n,kds){
		wl.KDS[n]=kds;
		if(n==D) n.attachEvent?n.attachEvent('onkeydown',wl.KDHandlerD):n.addEventListener('keydown',wl.KDHandlerD,false);
		else n.attachEvent?n.attachEvent('onkeydown',wl.KDHandler):n.addEventListener('keydown',wl.KDHandler,false);
	}
	// Stop event propagation
	this.stopPropagation=function(event){
		try{event.stopPropagation()}catch(er){event.cancelBubble = true}
	}
	// Prevent backspace key to go back to previous page (instead try goBack function)
	this.blockBackspace=function(){
		D.onkeydown=function(e){
			if(!e) e=W.event;
			if(wl.eventKC(e)!==8) return true;
			var t=e.target||e.srcElement;if(t&&t.tagName!='INPUT'&&t.tagName!='TEXTARREA') {
				if(W.goBack) setTimeout('goBack()',5);
				return false
			}
		}
	}


	// Add 2 1-level objects, return result
	this.objectsAdd=function(a,b){
		for(var e in b) a[e]=b[e];
		return a;
	}

	// Return true if browser is upload-drag & drop capable
	this.uploadDragDropCapable=function (){return (W.FileList)?1:0}




	/**
	* Buttons (button CSS class, outButton PHP function)
	*/
	function button(){}
	this.button=new button();

	// HTML code for creating a button
	button.prototype.create=function (caption,script,icon,id,disabled){
		var iht='<a ';
		if(id) iht+='id="'+id+'" ';
		if(caption) iht+='title="'+caption+'" ';
		if(disabled) iht+='class="buttonDisabled" href="javascript://'+script+'">';
		else iht+='class="button" href="javascript:'+script+'">';
		iht+='<i>&nbsp;</i><b>';
		if(icon) {
			iht+='<img alt="" src="'+icon+'" onclick="'+((disabled)?'//':'').script+'" ';
			if(caption && caption.length>0) iht+='style="margin-right:0.4em"';
			iht+='>';
		}
		else
		iht+='<img alt="" src="/gfx/v.gif">';
		iht+='<span></span><span>'+caption.replace(/ /g,'&nbsp;')+'</span></b><u>&nbsp;</u></a>';
		return iht;
	}
	// Is button enabled ?
	button.prototype.isEnabled=function (bt){
		if(!bt && !dgi(bt)) return false;
		return ($(bt).e.className().has('buttonDisabled'))?0:1;
	}

	// Enable button
	button.prototype.enable=function (bt,en){
		if(en===false||en===0) return wl.button.disable(bt);
		if(typeof bt=='string') bt=dgi(bt);

		if(!bt || bt.className=='button') return;

		// Set class
		bt.className='button';

		// Reset action / href
		var da=bt.getAttributeNode("disabledaction");
		if(da) da=da.value;

		if(da && da.substr(0,11)=='javascript:') {
			bt.onclick=function() {eval(da.substr(11))};
			bt.tmponclick=da.substr(11); // IE issue WA: getAttributeNode("onclick") doesn't return anything after setting onclick with the line above
		}
		else bt.href=da;
	}

	// Disable button
	button.prototype.disable=function (bt){
		if(typeof bt=='string') bt=dgi(bt);
		if(!bt || bt.className=='buttonDisabled') return;
		bt.className='buttonDisabled';

		var js=bt.getAttributeNode("onclick");
		if(bt.tmponclick || (js && js.value && js.value!=='null')) {
			bt.disabledaction='javascript:'+((bt.tmponclick)?bt.tmponclick:js.value);
			bt.onclick='void(1)';
		}
		else {
			bt.disabledaction=bt.href;
			bt.href='javascript:void(0)';
		}
	}

	// Set icon
	button.prototype.setIcon=function (bt,nSrc){
		if(typeof bt=='string') bt=dgi(bt);
		if(!bt) return;
		var img=bt.firstChild.nextSibling.firstChild;
		if(img.tagName=='IMG') img.src=nSrc;
		else img.style.filter=img.style.filter.substr(0,img.style.filter.indexOf("src='")+5)+nSrc+"')";
	}

	// Set caption/label
	button.prototype.setCaption=function (bt,txt){
		if(typeof bt=='string') bt=dgi(bt);
		if(!bt) return;
		if(bt.firstChild.nextSibling.firstChild.nextSibling.nextSibling)
			bt.firstChild.nextSibling.firstChild.nextSibling.nextSibling.innerHTML=txt;
		else
			bt.firstChild.nextSibling.firstChild.nextSibling.innerHTML=txt;
	}

	// Set function
	button.prototype.setFunction= function (bt,funcTxt){
		if(typeof bt=='string') bt=dgi(bt);	if(!bt) return;
		if(bt.className=='button'){
			bt.href='javascript:'+funcTxt;
			var img=bt.firstChild.nextSibling.firstChild;
			if(img) img.onclick=function(){eval(funcTxt)}
		}
	}

	/**
	* Block items functions
	*/
	function bI(id){if(typeof id == 'string') this.n=dgi(id); else this.n=id;}
	bI.prototype.enable=function(doEnable){if(doEnable || doEnable==undefined) $(this.n).e.className().remove('biDisabled'); else $(this.n).e.className().add('biDisabled')}
	bI.prototype.over=function(){if(this.n.className.indexOf("biDisabled")==-1) $(this.n).e.className().add('biOver')}
	bI.prototype.out=function(){$(this.n).e.className().remove('biOver')}

	/**
	 * Select a block item
	 * @param doSelect: true or indefined to select, 0 or false to unselect
	 * @param check: ?
	 */
	bI.prototype.select=function(doSelect,check){
		var na,e;
		if($(this.n).e.className().has('biDisabled')) return;
		if(doSelect||doSelect==undefined) {
			// Set item as selected (or remove selection if already selected & checkbox
			if(check && $(this.n).e.className().has('biSel')) $(this.n).e.className().remove('biSel'); else $(this.n).e.className().add('biSel');
			// unselect other blockitems
			if((na=this.n.getAttribute('name')) && !check) {
				var items=D.getElementsByTagName('FIELDSET');
				for(e in items) if(items[e] && items[e].getAttribute && items[e].getAttribute('name')==na && items[e]!=this.n) wl.blockItem(items[e]).select(0);
			}
		}
		else $(this.n).e.className().remove('biSel')
	}
	bI.prototype.selected=function(){return this.n.className.indexOf("biSel")!=-1}
	bI.prototype.enabled=function(){return this.n.className.indexOf("biDisabled")==-1}
	this.blockItem=function(id){return new bI(id)}

	// Block items group
	function bIG(name){this.n=name}
	bIG.prototype.getItems=function(){
		var r=[],l=D.getElementsByTagName('FIELDSET');
		for(e in l) if(l[e] && l[e].getAttribute && l[e].getAttribute('name')==this.n) r.push(new wl.blockItem(l[e]));
		return r;
	}
	// Return an array of id of selected item(s)
	bIG.prototype.getSelectedItemsIds=function(){
		var s=Array(),items=D.getElementsByTagName('FIELDSET'),e,i=0;
		for(e in items) if(items[e] && items[e].getAttribute && items[e].getAttribute('name')==this.n && wl.blockItem(items[e]).selected()) s[i++]=items[e].id;
		return s;
	}
	this.blockItemGroup=function(name){return new bIG(name)}

	/**
	 * Rating control & management
	 */
	this.ratingItem=function(id,rate,small,opt){
		var rCapt='Rating: %1 by %2 user(s)'
		if(!W.ratingAllowed) return '';
		rate=''+rate;

		var rc=1*(rate.substr(0,2)), voted=1*rate.substr(2,1), nb=rate.substr(3);
		if(nb>0) rCapt=rCapt.replace(/%1/,rc/10).replace(/%2/,nb); else rCapt='';
		rc='r'+(5*Math.round(rc/5));
		if(!opt) opt={};

		var c='<div '+((opt.extraStyle)?'style="'+opt.extraStyle+'"':'')+' title="'+rCapt+'"><div id="rating_'+id+'" class="rating'+((small)?' small':'')+((opt.center)?' centered':'')+((voted)?' voted':'')+((nb>0)?'':' notRated')+'" '+((voted)?'':'onmousemove="wl.ratingMove(this)"')+' onmouseout="wl.ratingOut(this)" onmouseup="wl.rate(this,event)" name="'+rc+'"><div name="'+rate+'" class="stars '+rc+'"></div></div></div>';
		return c;
	}

	// Mouse move over rating node
	this.ratingMove=function(n){
		if($(n).e.className().has('voted')) return;
		var p=(mouseX-$(n).e.actualOffsetLeft())/n.offsetWidth;

		p=10*Math.ceil(p*5);
		wl.ratingSet(n,'r'+p)
	}
	// Mouse move over rating node
	this.ratingOut=function(n){
		if($(n).e.className().has('voted')) return;
		wl.ratingSet(n,n.getAttribute('name'))
	}
	// Set rating indicator, n is the bottom node, r the css rating (r10, r15...)
	this.ratingSet=function(n,r){
		var sn=$(n.firstChild);
		sn.e.className().add(r);
		for(i=10;i<55;i+=5) if('r'+i!=r) sn.e.className().remove('r'+i);
	}
	// Set rating tooltip
	this.ratingSetTT=function(n){
		var rCapt='Rating: %1 by %2 user(s)', rate=n.firstChild.getAttribute('name');

		var rc=1*(rate.substr(0,2)), voted=1*rate.substr(2,1), nb=rate.substr(3);
		if(nb>0) rCapt=rCapt.replace(/%1/,rc/10).replace(/%2/,nb); else rCapt='';
		n.parentNode.title=rCapt;
	}
	// Do rate a file
	this.rate=function(n,e){
		if($(n).e.className().has('voted')) return;
		var rate=n.firstChild.getAttribute('name'),c,s,newRate, p=(mouseX-$(n).e.actualOffsetLeft())/n.offsetWidth;
		var rc=1*(rate.substr(0,2)), voted=1*rate.substr(2,1), nb=rate.substr(3);

		$(n).e.className().add('voted'); // has voted!
		$(n).e.className().remove('notRated');
		p=Math.ceil(p*5);

		c=0.1*rc;
		s=5*Math.round(2*(c*nb+p)/(nb+1));

		// Store new rating to set stars
		wl.ratingSet(n,'r'+s)
		n.setAttribute('name','r'+s); n.name='r'+s;

		// Store new values in subnode so tooltip can be set
		tmp=''+Math.floor(s)+'1'+(1*(nb+1));
		n.firstChild.setAttribute('name',tmp); n.firstChild.name=tmp;

		// Update tooltip
		wl.ratingSetTT(n);

//alert(nb+' votes, average='+c+' new='+s)

		// Find file name
		id=n.id.substr(7);
		if(id==='preview') name=preview.filename; // Preview image
		else if(W.fL) name=fL.files[id][2]; // File list
		else name=dgi('id'+id).innerHTML; // Old method: retrieve name from HTML node

		// Send
		fAS(name,'rate',p,false,'async')

		// Cancel context menu
		wl.cancelCM=wl.chrono.microtime()+500;
	}

	this.tmp=(function(){lFunc('common',10)})()

	/**
	* UI communication
	* Send command to UI
	* If returnDataName set, fill result into input named so, and fire onkeyup event
	* Else if callback set, call callback function with return value
	*/
	this.UICommandCallbackF=0;
	this.UICommandCallbackN=0;
	this.UICommandCallback=function (e){
		if((typeof wl.UICommandCallbackF)=='string') eval(wl.UICommandCallbackF+'(wl.UICommandCallbackN.value)');
		else wl.UICommandCallbackF(wl.UICommandCallbackN.value);
	}
	/**
	 * @desc Send command to UI app
	 * @param string command: command:
	 *				- close: close window. "close:returnparams": close window and inject result into opener (or return value to UI)
	 *				- show: bring window to front
	 *				- fadesize: fade window size. returnDataName: widthxheight (use 0 on width or height not to modify)
	 *				- openFile: file open dialog. returnDataName: filter:callbackInputName (filter format: *.jpg;*.gif;*.png)
	 *				- openFolder[:utf8Path]: folder open dialog. returnDataName: default usage (see below)
	 *				- webcamConfigure, webcamSelectFormat, webcamStatus: webcam commands
	 *				- webpopup:url : open an UI popup on given url.
	 *				- pluginmanagement: open plugins management popup
	 *				- installfromfile: install a theme/plugin from a local file. returDataName: path to file
	 *				- setCancelReturnArgs:
	 *				- openProfile: open profile configuration interface
	 *				- reloadGeneral: reload general.ini from file into UI
	 *
	 * @param string returnDataName: command's arguments (see above).
	 *								 Default usage: inject result into <input> named returnDataName an call onkeyup for this control
	 *
	 * @param string callback: javascript function called with result
	 */
	this.UICommand=function(command, returnDataName, cb){
		var n,l;

		if(cb && !returnDataName){
			n=dgi("uicommandcb")
			if(!n){
				n=D.createElement('INPUT');
				n.id='uicommandcb';
				n.name='uicommandcb';
				returnDataName='uicommandcb';
				with(n.style){position='absolute';top=0;display='none';}
				D.body.appendChild(n);
			}
			wl.UICommandCallbackF=cb;
			wl.UICommandCallbackN=n;
			n.onkeyup=this.UICommandCallback;
			returnDataName='uicommandcb';
		}
		l="UI:"+command+((returnDataName)?':'+returnDataName:'')

		// Send command to Qt through status modification
		W.status=l;

		// Send command to VB through address modification
		if(W.appType!='Qt') top.location.href=l;
	}

	/**
	 * Send a command to UI
	 * @param args: assoc array of arguments
	 * @param callbackFunctionName: callback function name
	 */
	this.UICommandV2=function(command,args,callbackFunctionName){
		var argStr='',l='UI2:'+command+':'+callbackFunctionName+':';
		for(var e in args) argStr+=((argStr)?'|':'')+e+"="+args[e];
		l+=argStr;

		// Send command to Qt through status modification
		W.status=l;

		// Send command to VB through address modification
		if(W.appType!='Qt') top.location.href=l;
	}

	/**
	 * @desc Open a web popup in application, and callback cb function (or function name) with return string
	 * @param string url: popup's URL
	 * @param function cb: called back function (with popup's "result" as parameter)
	 * @param array opt: options('width', 'height', 'resizable','windowsId':id of new window, 'label': title of new window,)
	 */
	this.UIWebPopup=function(url,cb,opt){
		var e,options='',id;
		if(opt){
			for(e in opt) options+=((options)?',':'')+e+':'+opt[e];
			if(options) options='{'+options+'}:';
		}
		else opt={};

		// In application: ask app open window by sending command into location
		if(W.isApp===1)	wl.UICommand('webPopup:'+options+url,false,cb);

		// No-popup mode
		else if(W.winMe && noPopup) {
			//alert(cb.toString().substr(9,cb.toString().indexOf('(')-9))

			id=(opt.windowId)?opt.windowId:'winId'+Math.random(9999);
			parent.winOpenLocation(url,id,'',W.winMyId);
			opt.noAnimation=1; // Force no animation to limit resize problems
			with(parent.win(id)){
				resizeTo((opt.width)?opt.width:200,(opt.height)?opt.height:200);
				center();
				show(opt);
				bringToFront();
			}
			parent.win(id).setProperty('callback',cb);
		}
		else{

		}
	}
	// web popup response return
	this.UIWebPopupReturn=function(data){
		if(isApp===1) wl.UICommand('close:'+data);
		else if(W.winMe && noPopup){
			parent.win(winMyId).getProperty('callback')(data);
			winMe.closeMe();
		}
	}
	// Set response of UI web popup when closed by user with esc or window closed
	this.UIWebPopupSetCancelReturnArgs=function(r){
		wl.UICommand('setCancelReturnArgs:'+r);
	}
	// Inject a key/value response from UI (popup or file/folder dialog)
	this.UIResultInject=function(key,val){
		var k,v;

		if((k=dgn("UIReturnVarName")) && (v=dgn("UIReturnValue"))){
			k.value=key;
			v.value=val;
			v.onkeyup();
		}
		if((k=dgn(key)) && (k.tagName=='INPUT')){
			k.value=val;
			k.onkeyup();
		}
	}
	// Adjust popup height to actual conent height
	this.webPopupAdjustHeight=function(fade){setTimeout('wl.webPopupAdjustHeightT('+((fade)?1:0)+')',10)}
	this.webPopupAdjustHeightT=function(fade){
		var e,l=D.body.childNodes,max=0,t;
		for(e in l) {
			t=actualOffsetBottom(l[e]);
			if(!isNaN(t) && t>max) max=t;
		}
		max+=15;

		if(W.isApp===1)	{
			if(fade) wl.UICommand('fadeSize','0x'+(max)); else wl.UICommand("setSize","0x"+(max));
		}
		else if(W.winMe && noPopup)	winMe.resizeInnerTo(false,max);
	}


	/**
	 * Show help
	 */
	this.showHelp=function(capt,title){
		var a=W,b=W;while(a.parent && a!=a.parent) {
			a=a.parent;
			try{if(a.dd) b=a} catch(e){break;}
		}
		b.sendData('hId='+capt+'&hTId='+title,'/help.php');
	}

	/**
	 * @desc Copy text to clipboard (IE)
	 * @param string id: id of INPUT/TEXTAREA node or plain text
	 */

	this.clipboardCopy=function(id){
		if(!dgi(id)){
			$('tmpClip').e.create('INPUT',{'value':id,'style':'display:none'})
			id='tmpClip';
		}
		with(dgi(id).createTextRange()){
			execCommand("RemoveFormat");
			execCommand("Copy");
		}
		if(id=='tmpClip') $(id).e.remove();
	}



	/**
	* Fade any CSS p from current to "end" state
	* @param id: id of node
	* @param p: style property to fade
	* @param end: final state (no unit set, use current state's)
	* @param type: 'linear' or 'exponential'  (opt:linear)
	* @param nbSteps: 'linear' or 'exponential' (opt:imgFadeSteps)
	* @param cb: callback on completition (opt:no)
	*/
	this.fadeStyle=function (id, p, end, type, nbSteps, cb){
		var isStyle=(p!='scrollTop'&&p!='scrollLeft');

		var n=dgi(id),s=(isStyle)?n.style:n;val=''+s[p],unit='',v=0;
		if(val==''){
			if(p=='height') val=''+n.offsetHeight+'px';
			if(p=='width') val=''+n.offsetWidth+'px';
		}

		if(val.substr(val.length-1)=='%') unit='%';
		if(val.substr(val.length-2)=='px') unit='px';
		v=1*val.substr(0,val.length-unit.length);

		// Set number of steps
		if(nbSteps==undefined) {if(v==end) nbSteps=1; else nbSteps=10;}
		if(nbSteps<=1) v=end;
		else {if(type=='exponential') v=(2*v+end)/3; else	v+=(end*1-v*1)/nbSteps;}

		if(p=='alpha') setAlpha(n,v);
		else {
			if(Math.floor(v)==0 && (p=='height'||p=='width')) s.display='none'; // IE WA: height/width 0px doesn't work
			else s[p]=''+Math.floor(v)+unit;
		}

		if(nbSteps<=1){if(cb && cb!=='undefined') eval(cb); return;}
		W.setTimeout('wl.fadeStyle("'+id+'", "'+p+'", '+end+', "'+type+'", '+(nbSteps-1)+', "'+cb+'")',((phpBrowser=='gecko')?50:5));
	}

	/**
	 * ext/img functions
	 */
	this.extImageSrc=function (filename,w,h,opt){
		if(!opt) opt={};
		return '/img/w.'+w+'/h.'+h+'/cache.'+((opt['noCache'])?0:1)+'/resId.'+resId+'/file.'+encodeURIComponent(filename).replace(/%2F/g,"/");
	}

	this.tmp=(function(){lFunc('common',10)})()

	/**
	 * Preload an image into browser cache
	 * @param src: image src
	 * @param src: onloadCallback: function called on image load
	 */
	this.imgPreload=function(src,onloadCallback,onerrorCallback){
		var i=new Image()
		if(onloadCallback) i.onload=onloadCallback;
		if(onerrorCallback) i.onerror=onerrorCallback;
		i.src=src;
	}

	/**
	 * Asynchronous requests
	 */
	this.AsynchronousRequest=function (){
		this.seq=1; // Sequential number of requests
		this.reqs={}; // Array of id=>requests
		this.method='POST'; // Default requests method (allways GET, may be set tp POST);

		/**
		 * Main async request function
		 * d: data, url encoded or associative array
		 * url: target URL, current if not set
		 * mode: 0=immediate, 1=queue if other requests in progress
		 * opts: options array 'uploadProgress':function
		 * Return: request id, or 0 if failure
		 */
		this.send=function (d,url,mode,opts){
			var e,r,dGet='';

			// If data is a file,don't do anything now
			if(d.fileSize || d.size)	dGet=d;
			// Convert args array to URL encoded format
			else {
				// if any extra arguments defined, add them to passed arguments (used by resource configuration scripts)
				if(wl.asr.extraArgs) {for(e in wl.asr.extraArgs) dGet+='&'+e+'='+encodeURIComponent(wl.asr.extraArgs[e])}

				if(typeof(d)=='object'){for(e in d) dGet+='&'+e+'='+encodeURIComponent(d[e])} else dGet=d;
				dGet=dGet.replace(/\+/g,"$weezoPlus$")+"&asyncRequest=1"+((W.resId)?"&resId="+resId:"");
				if(dGet.substr(0,1)=='&') dGet=dGet.substr(1);
			}

			// Fill URL
			if(!url) url=D.location.href;
			// Set mode
			if(mode!=1) mode=0;
			// Create request
			if(!(r=new this.request(dGet,url,mode,opts))) return 0;
			// Store in requests array
			wl.asr.reqs[r.id]=r;
			// Send or let in queue
			if(!mode || count(wl.asr.reqs)==1) r.send();
			return r.id;
		}

		/**
		 * Cancel all requests
		 */
		this.cancelAll=function (){
			var limit=0;
			while(count(wl.asr.reqs) && limit++<5) for(e in wl.asr.reqs) {
				wl.asr.reqs[e].cancel();
			};
		}

		/**
		 * Cancel single request (also called on request completed)
		 * req: request or request id
		 */
		this.cancel=function (req){
			var id;
			if(typeof req!='object') id=req; else id=req.id;
			if(wl.asr.reqs[id]){
				// Stop if still in progress
				if(wl.asr.reqs[id].state==2) try{wl.asr.reqs[id].abort()} catch(e){}
				// Remove from list
				try{
					if(W.bBrowser!=="IE6"){
						with(wl.asr.reqs[id].xhr){
							onreadystatechange = null
							abort=null
						}
						wl.asr.reqs[id].xhr=null;
					}
					delete(wl.asr.reqs[id]);
				}
				catch(e){try{delete(wl.asr.reqs[id])} catch(e){}}

			}
			// Launch next pending request
			for(var e in wl.asr.reqs) if(wl.asr.reqs[e].state==1) return wl.asr.reqs[e].send();
		}

		/**
		 * Return request item from id
		 */
		this.getRequest=function (id){return wl.asr.reqs[id];}

		/**
		 * Request object. See .send() above for args (except d must be url-encoded if it's not a file upload)
		 */
		this.request=function (d,url,mode,opts){
			var rid=wl.asr.seq++,e,rh;
			this.data=d; // Request data (url-encoded query string)
			this.url=url;
			this.opts=(opts)?opts:{}; // Options
			this.id=rid; // Request id, index of ASR.reqs array
			this.state=mode; // Request state (0, pending, 1 in queue, 2 in progress, 3 completed (process in progress)
			this.RTReadBytes=0;
			this.RTProcessed=0;
			this.method=wl.asr.method;

			// Detect data is a file => switch to file upload mode
			if(d.fileSize || d.size) this.method = 'FILE';

			// All browsers except IE6-
			if(W.XMLHttpRequest) this.xhr = new XMLHttpRequest();
			// IE6- or IE7+ with disabled native XMLHTTP request
			else if (W.ActiveXObject) {
				try{this.xhr = new ActiveXObject("MSXML2.XMLHTTP.6.0")}
				catch(e){
					try{this.xhr = new ActiveXObject("Microsoft.XMLHTTP");}
					catch(e){alert('XMLHttpRequest error: Internet Explorer asynchronous request and ActiveX disabled');return false}
				}
			}
			try{this.xhr.id=rid}catch(e){} // Also store id in XMLHttpRequest object

			/**
			 * Do send data
			 */
			this.send=function(async){
				if(async==undefined) async=true;

				this.url=wl.insertSessionIDInURL(this.url);

				// GET request (only if query string not too long)
				if(this.method=='GET' && d.length<1950) {
					// Open
					if(url.indexOf('?')!=-1) this.xhr.open("GET", url+'&'+d,async); else this.xhr.open("GET", url+'?'+d, async);
					this.method='GET';
					// Send
					this.xhr.send(null);
				}
				// POST / FILE request
				else {
					// Upload progress listener (must be set before xhr.open to work in FF
					if(this.opts.uploadProgress) this.xhr.upload.addEventListener("progress", function(e){wl.asr.reqs[rid].opts.uploadProgress(wl.asr.reqs[rid],e)}, false);
					// Upload completed listener (must be set before xhr.open to work in FF
					if(this.opts.uploadCompleted) this.xhr.upload.addEventListener("load", function(e){wl.asr.reqs[rid].opts.uploadCompleted(wl.asr.reqs[rid],e)}, false);
					// Open

					this.xhr.open("POST", this.url, async);
					// Set headers
					if(rh=this.opts.requestHeaders){ // Extra request headers
						for(e in rh) this.xhr.setRequestHeader(e, rh[e]);
					}
					if(this.method=='POST')
						this.xhr.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
					// file upload
					else if(this.method=='FILE'){
						this.xhr.setRequestHeader('Content-Type', 'multipart/form-data');
						this.xhr.setRequestHeader('X-Upload-File-Name', this.data.fileName);
						this.xhr.setRequestHeader('X-Upload-File-Size', (this.data.size)?this.data.size:this.data.fileSize);
						this.xhr.overrideMimeType('text/plain; charset=x-user-defined-binary');

						//this.xhr.open("POST", this.url, async);

						// Send
						if(this.data.getAsBinary) this.xhr.sendAsBinary(this.data.getAsBinary());
						else this.xhr.send(this.data);
					}
					// Send (GET or POST)
					if(this.method!=='FILE') this.xhr.send(this.data);
				}
				this.state=2; // Set in progress
				this.data=''; // Clear request args as they are not needed any longer

				// Show request in progress
				wl.asr.setRequestIndicator(1)

				// Opera WA: use timer to monitor reception
				if(phpBrowser=='opera') {
					this.RTInt=W.setTimeout(this.xhr.onreadystatechange,100,this.id);
					this.TO=1;
				}
			}


			// Set callback
			this.xhr.onreadystatechange=function (id) {
				// Callback seems sometimes to be called after window is called, throwing an error on wl
				if(!window.wl) return;
				// this is xhr (FF)
				if(this && this.id) rid=this.id;
				// Called by timer (opera RT WA)
				else if(id && typeof(id)!='object') rid=id;

				// Retreive request
				var r,xhr,rt;
				r=wl.asr.reqs[rid];

				if(!r||!r.xhr) return; // Not in list anymore => canceled request
				xhr=r.xhr;

				if(r.TO) r.RTInt=W.setTimeout(r.xhr.onreadystatechange,100,id); // Restart timeout

				try{rt=xhr.responseText} catch(e){return} // IE Workaround on uncompleted requests

				// Real-time processing
				var rl=rt.length,s,e,c,geckoBuffer='';

				if(rl==r.RTReadBytes && xhr.readyState!=4) return;
				r.RTReadBytes=rl;
				while((e=rt.indexOf('</JSRT>',r.RTProcessed))>r.RTProcessed){
					s=rt.indexOf('<JSRT>',r.RTProcessed); c=rt.substring(s+6,e).replace(/&lt;/g,'<');
					// Process extracted js code
					if(W.PHPDebug) {try{eval(c)} catch(e){alert('RT Async err: '+e+"\n"+c)}} else eval(c); // prod
					r.RTProcessed=e+7;
				}
				if(xhr.readyState!=4) return;

				// Request completed: process
				wl.asr.setRequestIndicator(0);
				r.state=3;

				// Failed request
				if(xhr.status!=200 || !xhr.responseText.length) return r.cancel();

				// Process response
				var xmlRoot,act,c,n,ns,add,attr,o,i;
				if(!xhr.responseXML || (xmlRoot=xhr.responseXML.documentElement)==null){
					if(W.PHPDebug && xhr.responseText!='unauthorized access') alert('XML error: '+xhr.responseText);return r.cancel();
				}


				// Browse XML response nodes
				for(i=0;i<xmlRoot.childNodes.length;i++) if((n=xmlRoot.childNodes[i]).nodeType==1){
					if(n.firstChild) c=xmlRoot.childNodes[i].firstChild.nodeValue; else c='';
					act=n.nodeName;
					// Execute javascript
					if(act=="JSAction") {
						var c=(n.getAttribute('commitBuffer'))?geckoBuffer:c;
						if(W.PHPDebug) {try{eval(c)} catch(e){alert('Async err: '+e.description+"\n"+c)}} else eval(c);
					}
					// Change node(s) innerHTML
					if(act=="innerHTML"){
						if(n.getAttribute('add')) add=1; else add=0;
						ns=[];
						if(attr=n.getAttribute('nodeId')) ns[0]=dgi(attr);
						else if(attr=n.getAttribute('nodeName')) ns=D.getElementsByName(attr);
						else if(attr=n.getAttribute('nodeTagName')) ns=D.getElementsByTagName(attr);
						for(o=0;o<ns.length;o++) if(ns[o]){
							if(add) ns[o].innerHTML+=((n.getAttribute('commitBuffer'))?geckoBuffer:c);
							else ns[o].innerHTML=((n.getAttribute('commitBuffer'))?geckoBuffer:c);
						}
					}
					// Add data to gecko buffer
					if(act=="addToBuffer") geckoBuffer+=c;

					// Clear buffer
					if(n.getAttribute('commitBuffer')) geckoBuffer='';
				}

				// Remove request from list, proceed to next in queue
				r.cancel();
			}


			/**
			 * Cancel request function
			 */
			this.cancel=function(){wl.asr.cancel(this.id)}

			return this.id;
		}

		this.tmp=(function(){lFunc('common',10)})()

		// Set request-in-progress indicator
		this.setRequestIndicator=function (st){
			if(dgi('asyncRequestIndicator')) dgi('asyncRequestIndicator').style.display=(st)?'':'none';
			else if(W.asyncRequestIndicator) asyncRequestIndicator(st);
			else if(W.winMe) winMe.asyncRequestIndicator(st);
		}
	}

	this.asr=new this.AsynchronousRequest();


	/**
	 * Init stuff
	 */
	this.init=function(){
		var tmp,e,m=D.getElementsByTagName('meta');

		// Process meta tags normaly used by UI windows, indicating window size, label and icon
		try{
			if(W.winMe) for(e in m) {
				// Dimensions
				if(m[e].name=='X-UI-size'){tmp=m[e].content.split('x'); winMe.resizeInnerTo(tmp[0],tmp[1],1)}
				// Icon
				if(m[e].name=='X-UI-icon') winMe.setIcon('/gfx/'+m[e].content+'.png');
				// Title
				if(m[e].name=='X-UI-title') winMe.setTitle(m[e].content);
			}
		}
		catch(er){}

		// Set client capabilties
		if(userLogged && !W.clientCapSet) wl.setClientCapabilities();
	}
}
var wl=new wJSLib();

connect(W,'load',wl.init)






/**
 * Right-side Facebook comment frame
 */
function WComments(){
	var bannerWidth;

	return {
	'setBannerWidth':function(w){
		this.bannerWidth=w;
		$('commentsDiv').style.width=w+'px';
	},
	// Init banner width & set window resize & load callbacks
	'adjustSize':function(w){
		this.setBannerWidth(w);
		connect(W,'resize',this.onresize);
		connect(W,'load',this.onresize);
	},
	// Called on window resize, use to adapt to mainFrame top and bottom padding
	'onresize':function(){
		var wd=W.winDesk,n=$('commentsDiv');
		if(wd && (wd.top||wd.bottom)){
			if(wd.top) n.style.top=wd.top+'px';
			n.style.height=wd.height+'px';
		}
		if(dgi('topDiv')) $('topDiv').style.width=(n.offsetLeft-$('topDiv').offsetLeft)+'px';
	},
	'onfoldchange':function(){
		if(W.bodyResized) return bodyResized();
		 if(dgi('topDiv')) {
			if(dgi('topDiv')) $('topDiv').style.width=($('commentsDiv').offsetLeft-$('topDiv').offsetLeft)+'px';
		}
		if(W.winMe) winMe.resized();
	},
	'ontogglecomplete':function(){
		var n=$('commentsDiv'),state;
		state=(n.e.getStyle('right')!=='0px')?0:((n.offsetWidth>1.1*wComments.bannerWidth)?2:1);
		wl.asr.send('setCommentsPanelState='+state);
	},
	'toggle':function(dir){
		var n=$('commentsDiv'),f;

		// Unfold frame to widest pos
		if(n.e.getStyle('right')=='0px' && dir==1){
			if(n.offsetWidth>wComments.bannerWidth*1.1) return; // If frame is already fully unfolded, cancel
			f=function(p,anim){
				p=Math.round(anim.extraParameters.baseWidth*(wl.animFunctionUnfold1(p)+1))+'px';
				return {'width':p}
			}
		}

		// Fold frame to narrow pos
		else if(n.e.getStyle('right')=='0px' && dir==-1 && n.offsetWidth>wComments.bannerWidth*1.1){
			f=function(p,anim){
				p=Math.round(anim.extraParameters.baseWidth*(2-wl.animFunctionUnfold1(p)))+'px';
				return {'width':p}
			}
		}

		// Fold frame
		else if(n.e.getStyle('right')=='0px'){
			f=function(p,anim){
				p=Math.round(anim.extraParameters.baseWidth*(wl.animFunctionFold1(p)-1))+'px';
				return {'right':p}
			}
		}
		// Unfold frame
		else{
			f=function(p,anim){
				p=Math.round(anim.extraParameters.baseWidth*(wl.animFunctionUnfold1(p)-1))+'px';
				return {'right':p}
			}
		}

		// Start animation
		wl.anim({'item':n,
			'duration':500,
			'extraParameters':{'baseWidth':wComments.bannerWidth},
			'callbackStep':function(){WComments().onfoldchange()},
			'callbackComplete':function(){WComments().ontogglecomplete()},
			'function':f
		});
	}
	}
}













/*********************************************************************************************
 * Extended DOM node Object
 *********************************************************************************************/
function $(node){
	var n;
	if(!node) return {};
	if(typeof node=='string') {
		if(!(n=D.getElementById(node)) && !(n=dgn(node))) n={'id':node}; // Inexisting node, that will be used with .create function
		else n.ok=1;
		n.e=new wlNode(n);
		return n;
	}
	else{
		node.e=new wlNode(node);
		return node;
	}
}
function wlNode(node){this.n=node}

/**
 * Create DOM Node
 */
wlNode.prototype.create=function(tagName,attributes,parentNode){
	// Create node
	var e,n=D.createElement(tagName.toUpperCase()),s,sp;
	// Retreive id from creation
	n.id=this.n.id;
	// Set attributes
	for(e in attributes) {
		if(e=='style'){
			s=attributes[e].split(';');
			for(i in s){
				sp=s[i].split(':');
				n.style[sp[0].trim()]=sp[1].trim();
			}
		}
		else n.setAttribute(e,attributes[e]);
	}

	n.ok=1;
	// Store
	this.n=n;
	// Insert in DOM
	if(parentNode) parentNode.appendChild(n); else D.body.appendChild(n);
	return this;
}

// Remove DOM node
wlNode.prototype.remove=wlNode.prototype.del=function(){if((n=this.n) && n.parentNode) n.parentNode.removeChild(n)}

/**
 * Connect listener to object. Added support for cross-browser onmouseenter & onmouseleave
 * Args:
 * 	event name (with or without "on")
 * 	callback function
 */
wlNode.prototype.connect=function(){var a = arguments; connect(this.n,a[0],a[1])}

// Get actual style value, from style or css
wlNode.prototype.getStyle=function(styleProp){
	var s,n;
	if(!(n=this.n)) return;

	if (n.currentStyle) s=n.currentStyle[styleProp];
	else if (W.getComputedStyle) {
		if(n.id) n=dgi(n.id); // IE Workaround: n might be a wlNode instead of an HTML node, and getComputedStyle can only get an HTML node
		s=D.defaultView.getComputedStyle(n,null).getPropertyValue(styleProp);
	}
	return (s===undefined)?0:s;
}
/**
 * Recursively browse node's parent to find one with attrib (valuing value if value parameter is set)
 * @return parent node if found, 0 if none found
 */
wlNode.prototype.parentHasAttribute=function(attrib,value){
	var n=n=this.n;
	if(!n) return;
	while(n.parentNode && n!=n.parentNode) {
		n=n.parentNode;
		if(n[attrib]){
			if(value==undefined || value==n[attrib]) return n;
		}
	}
	return false;
}

// Set transparency (0<alpha<1)
wlNode.prototype.setOpacity=wlNode.prototype.setAlpha=function(alpha){
	setAlpha(this.n,alpha);
	return this;
}
// Set transparency (0<alpha<1)
wlNode.prototype.getAlpha=function(){
	if(this.getStyle('display')=='none' || this.getStyle('visibility')=='hidden') return 0;
	return (this.n.opacity)?this.n.opacity:1;
}
wlNode.prototype.setBoxShadow=function(x,y,w,col){
	this.n.style.boxShadow=this.n.style.MozBoxShadow=Math.round(x)+'px '+Math.round(y)+'px '+Math.round(w)+'px '+col;
}

// Fade node in (time is ms)
wlNode.prototype.fadeIn=function(time){
	var sA=this.getAlpha();
	if(!time) time=500;
	time*=(1-sA);
	if(sA==0) this.setAlpha(0);
	this.n.style.display="";
	this.n.style.visibility="visible";

	wl.anim({'item':this.n,'single':1,'duration':time,'function':function(p,a){return {'opacity':sA+(1-sA)*p}}});
	return this;
}
// Fade node out (time is ms)
wlNode.prototype.fadeOut=function(time){
	if(!time) time=500;
	var sA=this.getAlpha();
	time*=sA;
	wl.anim({'item':this.n,'single':1,'duration':time,'function':function(p,a){return {'opacity':sA*(1-p)}}});
	return this;
}

/**
 * Vertically toggle a frame(1/2/3) but let it's title displayed. Frame's title must be the 1st node and collapsed frame the 2nd.
 * @desc phpVarName: if set, name of php var updated with fold/unfold value
 * @desc jsCallbackFunctionName: name of js function called on completition
 */
wlNode.prototype.frameToggle=function(phpVarName,jsCallbackFunctionName){
	//var s=this.n.style, fs=this.n.firstChild.style, ns=this.n.firstChild.nextSibling;
	if(!this.className().has("collapsed")) this.className().add("collapsed"); else this.className().remove("collapsed");
	wl.nodeCollapseToggle(this.n.firstChild.nextSibling.id, phpVarName, '(function(a,b){if(b=="doneFold") $(a).style.display="none"; else if(b=="doneUnfold") $(a).style.height=""; if(W.winResized) winResized()})');
}

wlNode.prototype.verticalFadeInOut=function(fadeIn,time){
	var n=this.n,s=n.style,destH,startH,pos;
	if(!time) time=200;

	//alert(fadeIn+"-"+s.display)

	if(fadeIn && s.display!="none") return; // If item is already shown, abort
	if(!fadeIn && s.display=="none") return; // If item is already hidden, abort


	// Compute base/dest height
	if(fadeIn){
		pos=s.position;
		s.position='absolute';
		this.setAlpha(50);
		s.display='block';
		startH=0;
		s.overflow=''
		s.height='auto'
		destH=n.offsetHeight;

		if(phpBrowser!="ie") destH-=1*(this.getStyle("padding-top").toString().replace(/px/,''))+1*(this.getStyle("padding-bottom").toString().replace(/px/,''))
		s.height='1px';
		s.position=pos;
	}
	else{
		startH=this.n.offsetHeight;
		if(phpBrowser!="ie") startH-=1*(this.getStyle("padding-top").toString().replace(/px/,''))+1*(this.getStyle("padding-bottom").toString().replace(/px/,''))
		destH=1;
	}
	s.overflow='hidden';

	// Anim
	wl.anim({
		'item':this.n,
		'duration':time,
		'function':function(p,a){
			if(p==1){var s=a.item.style; if(fadeIn) s.overflow=""; else s.display='none';}
			return {
				'opacity':(fadeIn)?p:1-p,
				'height':(p*destH+(1-p)*startH)+'px'
			}
		}
	})
}

/**
 * @desc Sync submit a form. Add necessary data
 */
wlNode.prototype.submit=function(p){
	this.n.submit();
}

/**
 * @desc Return 1 if node is a child of p
 */
wlNode.prototype.isChildOf=function(p){
	var n=this.n;
	if (p===n) return 0;
	while (n && n!==p) n=n.parentNode;
	return n === p;
}

// Set image src (compatible with IE6 png fix)
wlNode.prototype.setSrc=function(src){
	if(this.n.tagName=='SPAN') {
		var f=this.n.style.filter;
		f=f.substr(0,f.indexOf('src=')+4)+src+f.substr(f.indexOf(','));
		this.n.style.filter=f;
	}
	else this.n.src=src;
	return this;
}


// Set iframe src without IE click sound
wlNode.prototype.updateIFrameSrc=function(src,forceClassicalIFrameSrcUpdate){

	src=wl.insertSessionIDInURL(src);

	if(forceClassicalIFrameSrcUpdate || phpBrowser=='ie') return this.n.src=src;

	var i, tmpId, nIF = D.createElement("iframe"), attr=['name','frameborder','frameBorder','scrolling','ok'];

	// Copy attributes
	for(i=0;i<attr.length;i++) if(this.n[attr[i]]) nIF[attr[i]]=this.n[attr[i]];
	nIF.src = src;

	// Set temporary style
	for(i in this.n.style) {try{nIF.style[i]=this.n.style[i]} catch(err){}}
	with(nIF.style){visibility='hidden';position='absolute'}

	// Change prev iframe id
	tmpId='tmpIF'+this.n.id;
	this.n.id=tmpId;

	// Set new frame id (cannot directly copy from source.id)
	nIF.id='new'+tmpId.substr(5);

	try{this.n.parentNode.insertBefore(nIF, this.n)} catch(er){}
	// Wait for new iFrame to load before showing
	connect(nIF,'onload',function(){
		var prev=$(tmpId),n=$('new'+tmpId.substr(5));
		with(n.style){
			visibility='visible';
			position='static';
		}
		// Copy source iframe style
		for(i in prev.style) {try{n.style[i]=prev.style[i]} catch(err){}}
		n.id=n.id.substr(3)
		prev.e.remove();
		try{frames[n.name].winResized()} catch(err){}
	});
}

/**
 * Add a keyup callback function to a node, called with keycode
 * @param cbFunction: callback function
 */
wlNode.prototype.setKeycodeListener=function (cbFunction){
	connect(this.n,'keyup',function(){cbFunction(wl.eventKC(W.event))} )
}


/**
 * Make a node resizable
 * @param DOM node handleNode: handle that will be used to resize node
 * @param DOM string prop: property to be changed: "width" or "height"
 * @param DOM array opts: 'firstChildWA' (set to true to also redim 1st child element (workaround for collapsable TD)), min, max
 */
wlNode.prototype.setResizable=function(handleNode,prop,opts){
	var n=this.n,s=n.style,destH,startH,pos;
	if(prop=='width') {
		n.wRes=1;
	}
	if(prop=='height') {
		n.hRes=1;
	}
	if(!opts.min) opts.min=0;
	if(!opts.max) opts.max=9999;

	// Cursor
	handleNode.style.cursor= ((opts.cursor)?opts.cursor:(prop=='width')?'e-resize':'n-resize');

	// Mouse down
	connect(handleNode,'mousedown',function(){
		var e=$(n).e, s=n.style;
		n.resizing=1;
		if(n.wRes){
			n.wResBase=(s.width)?s.width.replace(/px/,''):n.offsetWidth;
			n.mouseBase=W.mouseX;
			opts.dir=(handleNode.offsetLeft>n.offsetLeft)?-1:1;
		}
		else{
			n.hResBase=(s.height)?s.height.replace(/px/,''):n.offsetHeight;
			n.mouseBase=W.mouseY;
			opts.dir=(handleNode.offsetTop>n.offsetTop)?-1:1;
		}
	})

	// Mouse move
	connect((phpBrowser=='ie')?D:W,'mousemove',function(){
		var v,min=opts.min,max=opts.max;
		if(!n.resizing) return;
		if(n.wRes) v=1*n.wResBase+opts.dir*(1*n.mouseBase-1*mouseX);
		if(n.hRes) v=1*n.hResBase+opts.dir*(1*n.mouseBase-1*mouseY);
		if(typeof min=='string') eval('min='+min);
		if(typeof max=='string') eval('max='+max);

		v=Math.min(Math.max(min,v),max)
		if(n.wRes){
			s.width=v+'px'
			if(opts.firstChildWA) n.firstChild.style.width=s.width;
		}
		if(opts.onresize) eval(opts.onresize);

		handleNode.clickFrozen=1; // Prevent onclick function on handle if it's being dragged
	})
	// Mouse up
	connect((phpBrowser=='ie')?D:W,'mouseup',function(){
		n.resizing=0;
		setTimeout(function(){handleNode.clickFrozen=0},10)
	})
}

// Disable text/node selection in node and subnodes
wlNode.prototype.disableSelection=function(){
    this.n.onselectstart=function(){return false} // IE
    this.n.style.MozUserSelect="none" // FF
}

// Rotate node
wlNode.prototype.rotate=function(angle){var s=this.n.style;s.msTransform=s.WebkitTransform=s.MozTransform=s.OTransform='rotate('+(-angle)+'deg)';return this}
wlNode.prototype.rotateBy=function(angle){var a=this.getAngle();return this.rotate(angle-a)}
wlNode.prototype.getAngle=function(){
	var s=this.n.style,r=(s.MozTransform||s.WebkitTransform||s.OTransform);
	if(!r) return 0;
	if(r.CSS_ROTATE && r[r.CSS_ROTATE]) return 180*r[r.CSS_ROTATE]/Math.PI; // Opera
	if(!r.indexOf) return 0;
	if(r.indexOf('deg')!=-1) return 1*(r.substring(r.indexOf('(')+1,r.indexOf('deg')));
	if(r.indexOf('rad')!=-1) return 180*(r.substring(r.indexOf('(')+1,r.indexOf('rad')))/Math.PI;
}

// offsets from top-left corner of document
wlNode.prototype.actualOffsetLeft=function(){return actualOffsetLeft(this.n)}
wlNode.prototype.actualOffsetRight=function(){return actualOffsetRight(this.n)}
wlNode.prototype.actualOffsetTop=function(){return actualOffsetTop(this.n)}
wlNode.prototype.actualOffsetBottom=function(){return actualOffsetBottom(this.n)}

// Center item on page
// Optional: offX & offY: offset (used to tweak position)
wlNode.prototype.center=function(offX,offY){
	var w,h,l,t,n=this.n;
	if(W.winMe){w=winMe.getInnerWidth();h=winMe.getInnerHeight()}
	else if(W.dd){w=dd.getWndW();h=dd.getWndH()}
	else {w=W.innerWidth;h=W.innerHeight}

	l=(w-n.offsetWidth )/2+((W.pageXOffset)?W.pageXOffset:D.body.scrollLeft)+((offX)?offX:0);
	t=(h-n.offsetHeight)/2+((W.pageYOffset)?W.pageYOffset:D.body.scrollTop)+((offY)?offY:0);

	if(W.dd && n.id && dd.elements[n.id]) dd.elements[n.id].moveTo(l,t);
	else with(n.style){left=l+'px';top=t+'px'}
	return this;
}

/**
 * Toggle fullscreen for a node (used for video)
 * @param bool hwOnly: 1 to force "hardware" fullscreen, and abort if not supported)
 * @param bool setFullscreen: if set, force fullscreen if 1/true or force windowed if 0/false
 */
wlNode.prototype.toggleFullscreen=function(hwOnly, setFullscreen, fullscreenChangeCallback){
	var n=this.n;

	// Go fullscreen
	if(!W.isFullscreen || setFullscreen){
		W.isFullscreen=1;
		try{n.webkitEnterFullScreen()} catch(e){ // Mobile webkit
			try{n.webkitRequestFullScreen()} catch(e){
				try{n.mozRequestFullScreen()} catch(e){
					try{n.requestFullscreen()} catch(e){
						if(hwOnly) return 0;
						this.className().add('fullscreen');
					}
				}
			}
		}
		// Set callback, used to detect if user went back to windowed mode with escape key
		if(fullscreenChangeCallback){
			var i,l=['','moz','webkit'];
			D.onfullscreenchange=D.onmozfullscreenchange=D.onwebkitfullscreenchange=function(){
				fullscreenChangeCallback(W.isFullscreen=(D.fullscreenElement || D.mozFullScreen || D.webkitIsFullScreen));
			}
		}
	}
	// Switch back to windowed view
	else{
		W.isFullscreen=0;
		try{D.webkitCancelFullScreen()} catch(e){
			try{D.mozCancelFullScreen()} catch(e){
				try{D.cancelFullscreen()} catch(e){
					try{D.exitFullscreen()} catch(e){
						if(hwOnly) return 0;
						this.className().remove('fullscreen');
					}
				}
			}
		}
	}
	W.focus();
	return 1;
}

/**
 * Check for html support
 * @param string attr: attribute name
 */
wlNode.prototype.supportAttribute=function(attr){return (attr in this.n)?1:0}

/**
 * Cross-browsers placeholder
 * @param phTxt: text
 */
wlNode.prototype.setPlaceholder=function(phTxt){
    var pH="placeholder";
    if(this.supportAttribute(pH)) this.n[pH]=phTxt;
    else{
        this.n.value=phTxt;
        var tph=this;
        this.className().add(pH);
        this.connect("focus",function(){if(tph.className().has(pH)){tph.className().remove(pH);tph.n.value=""}})
        this.connect("blur",function(){if(tph.n.value=="") {tph.className().add(pH);tph.n.value=phTxt}});
    }
}



// Extended DOM node class functions
wlNode.prototype.className=function(){return new wlNodeClass(this.n)}
wlNodeClass=function(node){this.n=node}
// Add a class to node
wlNodeClass.prototype.add=function(cl){
	if(!(n=this.n)) return; // No node
	if(!n.className) return n.className=cl; // Node has no class
	if(n.className.indexOf(cl)!=-1) return; // Node already has class
	n.className=n.className?n.className+' '+cl:cl;
}
// Remove a class from node
wlNodeClass.prototype.remove=function(cl){
	if(!(n=this.n) || !n.className) return; // No node or no class
	n.className=n.className.replace(new RegExp("[ ]{0,1}"+cl),"")
}
// Check if node has a class
wlNodeClass.prototype.has=function(cl){return (this.n && this.n.className)?(this.n.className.indexOf(cl)!=-1):0}
// Toggle class
wlNodeClass.prototype.toggle=function(cl){if(this.has(cl)) this.remove(cl); else this.add(cl)}

// Turn a DIV/SPAN/... into an INPUT field
// attribs: assoc. array of attributes
wlNode.prototype.changeToInput=function(attribs){
	var i=D.createElement('INPUT');
	i.style.width=this.n.offsetWidth;
	i.style.height=this.n.offsetHeight;
	if(attribs) for(e in attribs) i[e]=attribs[e];
	i.value=this.n.innerHTML;
	if(!attribs||!attribs['className']) i.className='textInput';
	this.n.parentNode.insertBefore(i,this.n)
	this.remove();
}

/**
 * @desc Turn node into a horizontal handle, moving vertically and resizing above and below elements
 * @param array opt: options
 *				minHeight: minimum height of div above separator (in pixels)
 *				asyncVar: name of PHP var to be async updated with div above separator height
 *				callback: name of javascript callback called with div node above separator as parameter, div above separator height
 */

wlNode.prototype.setHSeparator=function(opt){
	var n=this.n;if(!opt) opt={};
	this.className().add('hSeparatorToggle');
	n.prev=n.previousSibling;
	if(n.prev.nodeType!=1) n.prev=n.prev.previousSibling;
	n.next=n.nextSibling;
	if(n.next.nodeType!=1) n.next=n.next.nextSibling;
	n.parent=n.parentNode;
	n.hSepStartY=0;
	n.opt=opt;
	n.minHeight=(opt.minHeight)?opt.minHeight:50;
	n.omm=function(){
		var hp,hn,my;
		if(!n.hSepStartY) return;

		hp=Math.max(n.minHeight,mouseY-n.hSepStartY+n.prevH);
		my=hp+n.hSepStartY-n.prevH;
		hn=Math.max(n.minHeight,-my+n.hSepStartY+n.nextH);
		n.next.style.height=hn+'px';
		hp=n.nextH-hn+n.prevH;
		n.prev.style.height=hp+'px';
		if(opt.callback) opt.callback(n.prev,hp);
	}
	n.omu=function(){
		var asv;
		n.hSepStartY=0;
		disconnect(D,'mousemove',n.omm);
		disconnect(D,'mouseup',n.omu);
		if(asv=opt.asyncVar) eval('wl.asr.send({"'+asv+'":n.prev.offsetHeight})');
	}
	n.onmousedown=function(e){
		this.hSepStartY=mouseY;
		this.nextH=this.next.offsetHeight;
		this.prevH=this.prev.offsetHeight;
		connect(D,'mousemove',n.omm);
		connect(D,'mouseup',n.omu);
	};
	return this;
}

/**
 * Set a status bar caption that will be displayed on mouse over item
 * @param caption: HTML code of caption
 */
wlNode.prototype.statusCaptionSet=function(caption){
	var n=this.n;
	n.statusCaptionHTML=caption;
	// Display status bar on mouseover
	connect(n,'mouseover',function(){
		if(!dgi('statusCaption')) $('statusCaption').e.create('DIV',{'class':'statusBar','className':'statusBar','style':'z-Index:500'})
		$('statusCaption').innerHTML=caption;

	});
	// Hide status bar on mouseout
	connect(n,'mouseout',function(){$('statusCaption').e.remove()});
	return this;
}
var dbgwn=0;
function dbgw(a){
	if( dbgwn++>30) return;
	alert(a)
}
// Script load monitoring
lFunc('common',10);