
// Change files layout
function filesLayoutSet(l){
	var e=wl.button.enable;
	e(dgi('filesLayout_list'));
	e(dgi('filesLayout_icons'));
	e(dgi('filesLayout_resource'));
	wl.button.disable(dgi('filesLayout_'+l));
	efTNSize((l==='list')?-1:undefined);
	fAS(false,"filesLayoutSet",l,0,(W.filesListDisplayed && l!='resource')?'async':'sync');
}

// Search for a file
var searchFileLast='', searchFileDialog;
function searchFiles(result){
	if(result){
		searchFileLast=result['input'];
		if(result['button']=='ok' && result['input'].length) {
			wl.loading.set('dialogBoxIcon');
			wl.button.disable(searchFileDialog.item('ok'))
			searchFileDialog.item('input').disabled=true;
			wl.button.setFunction(searchFileDialog.item('cancel'),'searchFileCancel()');
			// Start searching
			fAS("","searchFiles",result['input'],result['check'],"async");
			return true; // Don't close form
		}
		return;
	}
	var dbOpts={
		'icon':efSearchIcon,
		'title':efSearchTitle,
		'text':efSearchText,
		'input':searchFileLast,
		'buttons':{
			'ok':efSearchOkCaption,
			'cancel':efSearchCancelCaption
			},
		'mask':true
		}
	var c=wl.capt.searchFilesContent
	if(W.searchFilesContentAllowed) {
		dbOpts.check=searchFilesContentDefault;
		dbOpts.checkText=wl.capt.searchFilesContent;
	}
	searchFileDialog=new DialogBox(dbOpts,'searchFiles');

	searchFileDialog.show();
}

function searchFileCancel(){
	wl.asr.cancelAll();
	searchFileDialog.hide();
	fAS('','searchFileCancel','','');
}
/**
 * Function async called back when search is completed
 * @param array result: std files array
 * @param string totSize: formated total size
 */
function searchFileComplete(results,totSize){

	fa=results;
	totalSize=totSize;
	searchFileDialog.hide();
	// File1 & music1: call insertFiles function to display results
	if(W.insertFiles) insertFiles();
	// Regular files system: rebuild files list object
	else if(W.fL){
		fL=new FilesList(fa,fL.layout,fL.nodeId,fL.tnw,fL.dir);
		fL.draw();
	}
}

// Remote download
function rdl(inputId) {
	var url;
	if((url=dgi(inputId).value)=="") return;
	dgi(inputId).value="";
	fAS(url,"rdl","","");
}


// Multiple downloads / playlist
var mIsProcessing=0;
function mAdd(id){
	if(mIsProcessing) return;
	mProcessing(true);
	// Cancel return-to-position animation
	if(dd && dd.elements[id]) dd.elements[id].cancelAnim=1;
	if(dd && dd.elements['_'+id]) dd.elements['_'+id].cancelAnim=1;
	sendData("data3=mAdd&data2="+encodeURIComponent(fL.filename(id)), PHP_SELF, false);
}
// Add into opener window/frame
function mAddOpener(id){
	if(parent && winMe.getOpenerId()) parent.frames[parent.dgi(winMe.getOpenerId()+'_if').name].mAdd(id);
	else if(opener && opener.mAdd) opener.mAdd(id);
	else mAdd(id);
}
// Remove from list
function mSupp(id){
	if(mIsProcessing) return;
	mProcessing(true);
	sendData("data3=mSupp&data2="+encodeURIComponent(dgi(id).innerHTML), PHP_SELF, false);
}
// Remove all
function mSuppAll(){
	if(mIsProcessing) return;
	mProcessing(true);
	sendData("data3=mSuppAll", PHP_SELF, false);
}
// Add all current dir's files
function mAddAll(){
	if(mIsProcessing) return;
	mProcessing(true);
	sendData("data3=mAddAll", PHP_SELF, false);
}
// Start download of all selected files
function mDownload(){
	if(mIsProcessing) return;
	var prevT=D.forms.comForm.target;
	D.forms.comForm.target="_self";
	if(dgi("transfersIFrame")) setTimeout("updateTransfersIframe()",1000);
	fAS('','mDownload',false,false,'sync');
	D.forms.comForm.target=prevT;
}
function mBtDownload(){
	if(mIsProcessing) return;
	if(dgi("transfersIFrame")) setTimeout("updateTransfersIframe(0)",5000);
	D.forms.comForm.target="_self";
	fAS('','mBtDownload','','','sync');
}
function mProcessing(isProcessing){
	var a=dgi('mdlIcon'), b=dgi('mdlLoadingIcon'),c=dgi('mDlList');
	if(isProcessing){
		mIsProcessing=1;
		if(a) {a.style.display="none"; b.style.display="";}
		if(c) c.style.cursor='wait';
	}
	else{
		mIsProcessing=0;
		if(a) {b.style.display="none"; a.style.display="";}
		if(c) c.style.cursor='auto';
	}
}
function mToggleButtons(enabled){
	if(enabled){
		wl.button.enable("plPlayM3UBt");
		if(dgi("plPlayAllBtE") && dgi("plPlayAllBtD")) {dgi("plPlayAllBtE").style.display="inline"; dgi("plPlayAllBtD").style.display="none";}
		if(dgi("mDlDownloadE") && dgi("mDlDownloadD")) {dgi("mDlDownloadE").style.display="inline"; dgi("mDlDownloadD").style.display="none";}
		if(dgi("btDlDownloadE") && dgi("btDlDownloadD")) {dgi("btDlDownloadE").style.display="inline"; dgi("btDlDownloadD").style.display="none";}
		if(dgi("mDlClearE") && dgi("mDlClearD"))  {dgi("mDlClearE").style.display="inline";dgi("mDlClearD").style.display="none";}
	}
	else{
		wl.button.disable("plPlayM3UBt");
		if(dgi("plPlayAllBtE") && dgi("plPlayAllBtD")) {dgi("plPlayAllBtE").style.display="none"; dgi("plPlayAllBtD").style.display="inline";}
		if(dgi("mDlDownloadE") && dgi("mDlDownloadD")) {dgi("mDlDownloadE").style.display="none"; dgi("mDlDownloadD").style.display="inline";}
		if(dgi("btDlDownloadE") && dgi("btDlDownloadD")) {dgi("btDlDownloadE").style.display="none"; dgi("btDlDownloadD").style.display="inline";}
		if(dgi("mDlClearE") && dgi("mDlClearD"))  {dgi("mDlClearE").style.display="none";dgi("mDlClearD").style.display="inline";}
	}
}

// Delete a file or a folder
function sup(id) {
	if(!dgi(id)) return;
	if(!confirm(wl.capt.genConfirmSuppress.replace('%1',fL.filename(id)))) return;
	fAS(fL.filename(id),"sup","","");
	asyncKeepScrollPos();
	asyncSetPI(1);
}
// Rename a file or folder
function ren(id) {
	oldName=fL.filename(id).replace(/&nbsp;/g,' ').replace(/&amp;/g,'&');
	newName=prompt(wl.capt.explorerEnterNewName,oldName);
	if ((newName) && (newName!="")) fAS(fL.filename(id),"ren", newName.replace(/&/g,'&amp;')); else return;
	asyncSetPI(1);
}
// Move or copy a file or folder
function moveFile(idSource, idDest, copy){
	if(idSource=='mainTree_outer') return;// WA for problem resizing folders treeview

	if(idSource==idDest || !dgi(idSource) || !dgi(idDest)) return;

	var tn,srcLabel,destLabel,destPath,action;
	if(tn=treeNodeChecked(idDest)) {
		destPath=tn.getPath();
		destLabel=destPath.replace(/\*resourceBasePath\*/,'');
		destPath+='/'+fL.filename(idSource);
	}
	else{
		destLabel=fL.filename(idDest);
		destPath=fL.filename(idDest)+'/'+fL.filename(idSource);
		destPath=destPath.replace(/&nbsp;/g,' ');
	}
	srcLabel=fL.filename(idSource).replace(/&nbsp;/,' ');
	destLabel=destLabel.replace(/&nbsp;/g,' ').replace(/&amp;/g,'&');

	if(copy){
		if(!confirm(wl.capt.genConfirmCopy.replace('%1',srcLabel).replace('%2',destLabel))) return;
		action='cpy';
	}
	else{
		if(!confirm(wl.capt.genConfirmMove.replace('%1',srcLabel).replace('%2',destLabel))) return;
		action='ren';

		// Cancel return-to-position animation
		if(dd && dd.elements[idSource]) dd.elements[idSource].cancelAnim=1;
		if(dd && dd.elements['_'+idSource]) dd.elements['_'+idSource].cancelAnim=1;
	}

	fAS(fL.filename(idSource), action, destPath);
	asyncSetPI(1);
}
// Create a folder
function newFolder(id) {
	newName=prompt(wl.capt.explorerEnterFolderName,"");
	if ((newName) && (newName!="")) fAS(newName,"newFolder", "","");
}
// Sort files
function srt(field, order){
	D.comForm.data1.value=field;
	asyncSetPI(1);
	fAS(order,"srt","","",(W.filesListDisplayed&&filesListDisplayed!='resource')?'async':undefined);
}
// execute a file on server
function exe(id) {
	var now = new Date(), windowName="exec"+now.getTime();
	parameters=prompt(wl.capt.explorerEnterParameters,"");
	if (parameters==false || parameters) {
		W.open("about:blank",windowName, "toolbar=no,location=no,status=yes,scrollbars=no,resizable=no,menuBar=no,width=400,height=200");
		D.comForm.target=windowName;
		fAS(fL.filename(id), "exe",parameters,"");
		D.forms.comForm.target='';
	}
}
// Update transfers iframe
function updateTransfersIframe(reupdate){frames["transfersIFrame"].transfersRefresh(reupdate)}

// Return link to file download. id is id property of DOM node containing file
function dlURL(id){
	var fileName,dlToken='',i,targetURL;
	if(dgi(id)) fileName=fL.filename(id); else fileName=id;
	for(i=0;i<D.comForm.data1.value.length;i++) dlToken+=D.comForm.data1.value.charCodeAt(i);
	for(i=0;i<fileName.length;i++) dlToken+=fileName.charCodeAt(i);

	targetURL="/dl/dlToken"+dlToken+'/resId'+resId+'/'+D.comForm.data1.value+'/'+fileName;
	return targetURL.replace(/#/gi,"*weezoSharp*").replace(/\&/gi,"*weezoAmp*").replace(/\+/gi,"*weezoPlus*").replace(/\%/gi,"*weezoPercent*").replace(/ /gi,"%20");
}
// Download file (id must be "idXXX")
function dl(id){
	if(dragCancelOnclick) {dragCancelOnclick=false; return}
	if(dgi("transfersIFrame")) setTimeout("updateTransfersIframe()",1000);
	D.location.href=dlURL(id);
}
// Bittorrent download a single file
function btDl(id){
	if(dragCancelOnclick) {dragCancelOnclick=false; return}
	fAS(fL.filename(id),"btDl","","","sync");
}
// Share a file
function share(id){
	wl.asr.send({'directLinkShowRemoteForm':1,'filename':D.comForm.data1.value+'/'+fL.filename(id)});
}
// Send a file by email
function mailout(id){
	fAS(fL.filename(id),"mailoutShowRemoteForm");
	mailoutId=id;
}
function mailoutInputValid(mail){return wl.isValidMail(mail)}
function mailoutProceed(r){
	if(r.button!='ok') return;
	id=mailoutId;
	fAS(fL.filename(id),"mailoutSend",r.input,r.mailoutTitle+'|'+r.mailoutMessage);
}
function mailoutResult(ok,msg){
	var c='statusBar'+((ok)?'':' err');
	$('statusCaption').e.remove();
	$('statusCaption').e.create('DIV',{'class':c,'className':c,'style':'z-Index:500'})
	$('statusCaption').innerHTML=msg;

	setTimeout(function(){$('statusCaption').e.fadeOut()},2000);
}



/**
 * View file
 * @param id: id of file node
 * @param width: default window width, set to -1 to maximize
 * @param height: default window height, set to -1 to maximize
 * @param action: view (default), forceM3U
 */
function view(id,width,height,action) {
	var forceAsync=false,f=fL.filename(id),popupId;
	if(W.dragCancelOnclick && dragCancelOnclick) {dragCancelOnclick=false; return}

	// Set default action
	if(!action) action="view";

	// Set unique popup id except if resource requests multiple popups (files explorer so far...)
	popupId='viewWindow'+resId+((W.multipleViewPopup)?encodeURIComponent(f):'');

	// Special: m3u playlist downloaded to browser
	if(action=='forceM3U'){
		fAS(f,'view',"forceM3U",false,'sync');
		return;
	}

	// Inline player
	if(phpRVarInlinePlayer) {
		fAS(f,action,"firstLoad",width+"x"+height,forceAsync);
		D.comForm.target='';
		return;
	}


	// Frameless theme : sync open in same window
	if(!winFrames) {D.comForm.target="";forceAsync="sync";}

	// No popup (iframe win)
	else if(noPopup && winUseWindows){
		if(parent.dgi(popupId) && parent.dgi(popupId).innerHTML!=""){
			parent.win(popupId).bringToFront();
			if(width==-1 || W.viewMaximized) parent.win(popupId).maximize();
		}
		else{
			// Set as much as possible fullscreen
			var w=parent.dd.getWndW(), h=parent.dd.getWndH();
			if(width==-1) {width=w; height=h}
			if(!width) width=Math.min(Math.floor(5*w/6),640);
			if(!height) height=Math.min(Math.floor(5*h/6),480);
			parent.winOpenLocation("",popupId,"Weezo",winMyId);
			with(parent.win(popupId)){
				setReloadType('POST');
				if(!W.viewMaximized){
					moveTo(Math.floor((w-width)/2),Math.floor((h-height)/2));
					resizeInnerTo(width,height);
				}
				else{
					maximize({'noAnimation':1});
				}
				show();
				bringToFront();
			}
		}
		parent.win(popupId).setCaption(f);
		D.comForm.target=parent.dgi(popupId+'_if').name;
	}

	// Regular popup
	else{
		var w=screen.availWidth, h=screen.availHeight;
		// Set as much as possible fullscreen
		if(width==-1) {width=w; height=h}
		if(!width) width=Math.floor(2*w/3);
		if(!height) height=Math.floor(2*h/3);
		W.open("about:blank",popupId,"toolbar=no,location=no,status=yes,resizable=yes,menuBar=no,width="+width+", height="+height+", top="+Math.floor((h-height)/2)+", left="+Math.floor((w-width)/2));
		D.comForm.target=popupId;
	}

	fAS(f,action,"firstLoad",width+"x"+height,forceAsync); D.comForm.target='';
}

// Edit file
function edit(id) {
	return view(id,undefined, undefined, "edit");
}

// Display images from-to thumbnail, or change items per page
function goThumbnail(id,async){
	if(id==='') return;
	id=""+id;
	if(id.substr(0,3)=='ipp') fAS(id.substr(3),"changeItemsPerPage","","",async); else fAS(id,"goThumbnail","","",async)
}

/**
 * Display go progress indicator
 * set: true to set, false to remove
 */
function asyncSetPI(set){
	if(asyncSetPITO) clearTimeout(asyncSetPITO);
	if(set){
		asyncSetPITO=wl.setTimeout(wl.mask.show,900,1,1,'wait',0,'<img src="/gfx/loading2.gif" alt="">');
		if(W.winMe) winMe.setReloading();
	}
	else {
		if(W.winMe) winMe.setLoaded();
		wl.mask.hide();
	}
}
var asyncSetPITO;

/**
 * Indicate that next files refresh will keep vertical scrolling position
 */
function asyncKeepScrollPos(){if(W.fL) fL.keepScrollPos=1; else keepScrollPos=1}

// change directory
function go(id) {
	if(W.dragCancelOnclick && dragCancelOnclick) {dragCancelOnclick=false; return;}
	var res=(id=='..')?fAS('..',"go","",""):fAS(fL.filename(id),"go","","");
	asyncSetPI(1);
}

/**
 * Direct Navigation to an absolute or relative path
 * inputId: id of <input> containing relative path OR relative path
 * async: true or undefined to async refresh
 */
function goDirect(inputId,async) {
	var typedFileName=(dgi(inputId))?dgi(inputId).value:inputId;
	if(!typedFileName) typedFileName='.';
	if(dgi(inputId)) dgi(inputId).value="";
	fAS(typedFileName,"goDirect",'','',async);
	asyncSetPI(1);
}


// Go back to previous directory
function goBack(){
	fAS('..',"goBack","","")
	asyncSetPI(1);
}

/**
 * @desc Insert script used for playlist songs insertion / removal
 *
 */
function plAdd(id){
	if(mIsProcessing) return;
	mProcessing(true);
	fAS(fL.filename(id),'plAdd',false,false);
}
function plSupp(key){
	if(mIsProcessing) return;
	mProcessing(true);
	fAS(false,'plSupp',key,false);
}
function plUp(key){
	if(mIsProcessing) return;
	mProcessing(true);
	fAS(false,'plUp',key,false);
}
function plDown(key){
	if(mIsProcessing) return;
	mProcessing(true);
	fAS(false,'plDown',key,false);
}
function plPlay(id,w,h){var tmp=D.comForm.data1.value;D.comForm.data1.value='';view(id,w,h);D.comForm.data1.value=tmp;}
function plPlayAll(w,h,forcedFormat){
	var tmp=D.comForm.data1.value;D.comForm.data1.value='';
	if(forcedFormat=='forceM3U')view("*playlist*.m3u",w,h,'forceM3U');
	else view("*playlist*.m3u",w,h);
	D.comForm.data1.value=tmp;
}

function plToggleShuffle(val){fAS(false,'plToggleShuffle',val,'');}
// Mainplaylist
function plRefresh(fa){
	buff='';
	if(fa.length==0) {
		dgi("mDlList").innerHTML='<center style="width:99%;margin-top:'+(dgi("mDlList").offsetHeight/2-10)+'px">'+wl.capt.explorerAudioNoSongInPlayList+'</center>';
		return;
	}
	for(var i=0;i<fa.length;){
		buff+='<div id="_id'+seqId+'" class="eTC" eH=1 style="width:99%;position:relative" nowrap="nowrap">';
		buff+=dgi("plPlayBt").innerHTML.replace(/ITEMID/g,'id'+seqId);
		buff+=dgi("plSuppBt").innerHTML.replace(/ITEMID/g,i/2);
		buff+=fa[i+1];
		buff+='<span id="id'+seqId+'" style="display:none">'+fa[i]+'</span>';
		if(fa.length>2){
			if(i) buff+='<span style="position:absolute;right:0.5em;" onclick="javascript:plUp('+(i/2)+')">'+efIcoUp+'</span>';
			if(i<fa.length-2) buff+='<span style="position:absolute;right:1.8em;cursor:pointer" onclick="javascript:plDown('+(i/2)+')">'+efIcoDown+'</span>';
		}
		buff+='</div>';
		i+=2;
		seqId++;
	}
	dgi("mDlList").innerHTML=buff;
}

// Save generated playlist on server
function plStore(){
	var db=new DialogBox({'icon':'/gfx/sel.png','title':wl.capt.storePlaylistDesc,'text':'<br>'+wl.capt.explorerFilename,'input':'','buttons':{'ok':'OK','cancel':'CANCEL'},'mask':true},'plStoreProceed');
	db.show();
}
function plStoreProceed(res){if(res.button=='ok' && res.input) fAS(res.input,'plStore')}
// Save generated playlist on server
function plDelete(plId){
	fAS(plId,'plDelete')
}


// Enable / disable upload form
function uploadFormEnable(enable){
	var e=wl.button.enable,d=wl.button.disable,s='uploadFormSubmitButton';o='flashUploadOpenBt';
	uploadAllowedDir=enable;
	if(enable) {e(s); e(o)}	else{d(s); d(o)}
	if(W.uploadDD) for(e in uploadDD) uploadDD[e].updateButtonsState();
}

/**
 * @desc Function called on drop event
 *	idSource: id of dragged object
 *  idDest: id of drop target
 */
function dropFunction(idSource, idDest){
	if(idDest=="mDlList") {
		if(dgi("mDlPlaylist")) plAdd(idSource);
		else mAdd(idSource);
		return;
	}
	if(idDest=='actionsPanel_colTD') return;
	if(idDest=="previewOuterFrame") {preview.set(idSource); return;}
	if(W.moveFile) moveFile(idSource, idDest, mouseEvt && mouseEvt.e && mouseEvt.e.ctrlKey);
}

//return a string containing checked files names
function checkedFiles(){
	var i; var fileString="";var fileNameId;
	for(i=0;i<D.getElementsByName('cb').length;i++){
		if(D.getElementsByName('cb')[i].checked==true) {
			fileNameId=D.getElementsByName('cb')[i].id
			fileNameId=fileNameId.substring(2,fileNameId.length)
			fileString+='f="'+dgi('id'+fileNameId).innerHTML+'" ';
		}
	}
	return fileString;
}

// Comments edition
function saveComments(){
	var commentText=dgi('efCommentsTextArea').value.replace(/\n/gi,"<br />"); // "
	fAS(dgi('efPreviewFileName').innerHTML, "saveComments", commentText,"",true);
}


// Sync/Async thumbnails update monitoring function
function tnUpdt(t,p){
	dgi('tnMonitoringDiv').style.display='';
	progressSetText('tnProg',t);
	progressSetPerc('tnProg',p);
}


var filesListElts=[];

/**
 * Explorer files list or icons view
 * @param files: array of files (see efFilesJSArray and efFilePropertiesToJSArray for definition)
 * @param layout: layout type: 'icons', 'list', 'customIcons' or 'resource'
 * @param nodeId: id of not containing files list
 * @param tnw: width of thumbnails (height is set to width)
 * @param curDir: current directory
 */
function FilesList(files,layout,nodeId,tnw,curDir){
	this.files=files; // List of files (Cf. efFilePropertiesToJSArray) for format
	this.dir=curDir; // Current directory, resoure-path relative
	this.layout=layout; // Layout type: 'icons', 'list', 'customIcons' or 'resource'
	this.nodeId=nodeId; // Id of container node
	this.tnw=tnw; // Current thumbnails width
	this.nb=(files)?files.length:0; // Nb of files
	this.cl=0;
	this.selectedId=0;
	this.UID=100*Math.random();
	this.noTooltip=0;
	this.contextMenuExtra; // Function called to modify context menu

	/**
	 * Get filename from an "id"
	 * id is historically the id of a node which innerHTML is filename, starting with "id" or "_id".
	 * but it may also be the filename itself
	 * To have a better result, this function now get the filename from the fL.files list
	 * @param string id
	 * @return string
	 */
	this.filename=function (id){
		//alert(id)
		if(this.files){
			if(id.substr(0,2)=='id' && (!isNaN(id.substr(2))) && this.files[id.substr(2)]) return this.files[id.substr(2)][2];
			if(id.substr(0,3)=='_id' && (!isNaN(id.substr(3))) && this.files[id.substr(3)]) return this.files[id.substr(3)][2];
		}
		return (dgi(id))?dgi(id).innerHTML:id
	}

	/*
	 * Transform file description array to a more comprehensible array
	 * mixed fileNb: index of file in files list or file description array
	 */
	this.file=function(fileNb){
	// 00 - id,
	// 01 - "d" for directories or "f" for files,
	// 02 - name,
	// 03 - draggable (0 or 1),
	// 04 - receiver (0 or 1),
	// 05 - icon path, (for directories : 0 for folder icon, 1 for locked folder icon)
	// 06 - editable (0 or 1), (0 for directories)
	// 07 - downloadable (0 forbidden, 1 ok without shortcut, 2 ok+shortcut), (0 for directories)
	// 08 - mdownloadable (0 or 1), (0 for directories)
	// 09 - file size,
	// 10 - modified date,
	// 11 - extra info,
	// 12 - unlinkable (0 or 1),
	// 13 - renamable (0 or 1),
	// 14 - excutable (0 or 1),
	// 15 - (files only) rating XXYZZ: XX is ratingx10, Y is 1 if user has voted or 0 if not, ZZ is the number of users who have voted. Rating is set to "-" if no one has voted
	// 16 - (files only) number of view

	// 17 - thumbnail URL (optional)
	// 18 - thumbnail w (optional)
	// 19 - thumbnail h (optional)
	// 20 - 1st letter of file mime (sub)type (a, m, v)
		var f=(isNaN(fileNb))?fileNb:this.files[fileNb];
		return {
			'id':f[0],
			'type':f[1],
			'isDir':(f[1]==='d'),
			'name':f[2],
			'draggable':f[3],
			'receiver':f[4],
			'icon':f[5],
			'editable':f[6],
			'downloadable':f[7],
			'mdownloadable':f[8],
			'size':f[9],
			'mdate':f[10],
			'extra':f[11],
			'unlinkable':f[12],
			'renamable':f[13],
			'executable':f[14],
			'rating':f[15],
			'nbView':f[16],
			'tnUrl':f[17],
			'tnW':f[18],
			'tnH':f[19],
			'mime':f[20]
		}
	}

	// Dynamic drag object creation
	this.sDF=function(n,DHTMLOptions,event){
		if(event && event.altKey) return; // On Chrome, pressing alt will trigger ondrag instead of onmousedown for outside-browser drag & drop
		var p,i=n.id,dragItem;
		if(i.substr(0,1)=='_'){p=i.substr(0,3);i=i.substr(3)} else{p=i.substr(0,2);i=i.substr(2)}
		if(dd.elements[p+i]) return;
		if(n.style.position!='absolute') n.style.position='relative';
		if(DHTMLOptions) dragItem=p+i+DHTMLOptions;
		else dragItem=p+i+INERTIA+CURSOR_HAND+ELASTIC+DETACH+EPHEMERAL+PICKDELAY+DRAGCLASS+400;
		if(dd.ie) {try{ADD_DHTML(dragItem,1);} catch(err){};} else ADD_DHTML(dragItem,1);

		// Add item to created DHTML elements list so it can be removed before next .draw()
		filesListElts.push(p+i)
	}

	/**
	 * Onload and onerr callbacks
	 * Set thumbnail image visible and proceed with queue
	 * If file is audio or video, transform file type's icon into an audio/video overlay
	 */
	this.lo=function(e,err){
		e=e||event;
		n=e.currentTarget||e.srcElement;
		// If image correctly loaded, transform icon into an overlay if file is a video or an audio file
		if(n&&!err) {
			var ns=n.nextSibling;
			if(ns) {
				if(W.filesListOverlayFunction) filesListOverlayFunction(ns); // If page has a custom overlay function (RUF)
				else{
					// Compute overlay size
					var olW=32;	if(fL.tnw>200) olW=140;	else if(fL.tnw>100) olW=70;
					// Set position
					ns.style.margin='-'+(olW/2)+'px 0 0 -'+(olW/2)+'px';

					// Set src
					if(count(fileTypeFilter)==1) removeNode(n.nextSibling); // Only one type of file displayed: don't show type overlay
					else{
						if(ns.src.indexOf('icoM3U')!=-1||ns.src.indexOf('icoMus')!=-1)	ns.src=efOverMus.replace(/\.png/,olW+'.png');
						else if(ns.src.indexOf('icoVid')!=-1) ns.src=efOverVid.replace(/\.png/,olW+'.png');
						else removeNode(n.nextSibling);
					}
				}
			}
			n.style.visibility=''
		}
		setTimeout('fL.l()',1);
	}
	this.le=function(e){fL.lo(e,1)}

	// Thumbnail onload function
	this.l=function(n,err){
		while(this.cl<this.nb){
			// If image has alt, put it into src and wait for it to be loaded
			if(dgi('f'+this.cl) && (n=dgi('f'+this.cl).firstChild.firstChild) && n.alt){
				this.cl++;
				n.onload=this.lo;
				n.onerror=this.le;
				n.src=n.alt;
				n.alt='';
				break;
			}
			this.cl++;
		}
	}

	// Detect wether right-click is done over an element
	this.onrightclick=function(e){
		var t=e?e.target:event.srcElement;
		var l=10; while(--l>0 && t) {
			if(t.id && (t.id=='filesTable'||t.id=='contextMenu'||t.id=='maskDiv')) return false;
			t=t.parentNode;
		}
		return true;
	}

	/**
	 *  Left click or context menu
	 * @param n: node
	 * @param e: event
	 * @param def: launchDefault
	 */
	this.cm=function(n,e,def){
		var o,f,ff,rc=((e && e.which == 3)||(W.event && event.button == 2)); // right-click
		var isDir=0, id, nid;

		// right-clicked file is directory
		if(n.id.substr(0,1)=='d'){
			isDir=1;
			nid=n.id.substr(1);
		}
		else{
			nid=(n.id.substr(0,3)=='_id')?n.id.substr(3):n.id.substr(1);
		}
		id='id'+nid;

		// Set selected item
		this.selectedId='id'+nid;

		if(wl.chrono.microtime()-wl.cancelCM<200) return; // Workaround for click on some sub items that should not trigger context menu

		// Left click
		if(!rc){
			if(o=dd.obj){
				if(o.pickTime()>350 || Math.abs(o.x-o.pickX)>10 || Math.abs(o.y-o.pickY)>10) return;
			}
			if(this.previewOnCM){
				if(typeof this.previewOnCM=='function') this.previewOnCM(id);
				else if(W.preview) preview.set(id); // If (image) preview function is present, call it
			}
			if(this.noLeftClickCM) return; // If no left-click context menu, exit
		}

		var pl=dgi('mDlPlaylist')?1:0; // A playlist drop-box is present (context menu will display "play" instead of "view"
		if(isDir && !rc) {go(id);return};
		f=this.files[nid];
		ff=this.file(nid);

		// Open dir
		var cmi=new Array();
		if(isDir) {
			cmi[0]=ContextMenuItem(false,efCaptOpen,'go(fL.selectedId)',1);
			cmi[1]=ContextMenuItem('sep');
		}

		// Downloadable
		if(f[7]){
			// View / play caption
			v=!isDir && ((f[20]=='v'||f[20]=='a'||f[5].indexOf('icoM3U')!=-1)||(f[5].indexOf('icoMus')!=-1)||(f[5].indexOf('icoVid')!=-1));

			// View / play menu entry
			if(!isDir && wl.rVar.fileViewAllowed) {
				cmi.push(v?ContextMenuItem(efIcoPlay,efCaptPlay,'view(fL.selectedId)',1):ContextMenuItem(efIcoView,efCaptView,'view(fL.selectedId)',1));
				/*
				if(ff.mime=='v') cmi.push(ContextMenuItem(efIcoPlay,efCaptPlay+' ('+efCaptFullscreen+')',"view(fL.selectedId,-1,-1,'viewFullscreen')"));
				if(ff.mime=='i') cmi.push(ContextMenuItem(efIcoView,efCaptView+' ('+efCaptFullscreen+')',"view(fL.selectedId,-1,-1,'viewFullscreen')"));
				*/
			}

			// Download shortcut allowed
			if(f[7]==2){
				cmi.push(ContextMenuItem('sep'))
				// Download
				cmi.push(ContextMenuItem(efIcoDl,efCaptDl+" ("+f[9]+")",'dl(fL.selectedId)'))
				// Bittorrent download shortcut (only for files > 1MB)
				if(efBtDl){
					var u=f[9].substr(f[9].length-2);
					if(u=="MB"||u=="GB") cmi.push(ContextMenuItem(efIcoBtDl,efCaptBtDl,'btDl(fL.selectedId)'))
				}
			}
			cmi.push(ContextMenuItem('sep'));
			// Share
			if(wl.rVar.shareAllowed){
				cmi.push(ContextMenuItem(efIcoShare,efCaptShare,'share(fL.selectedId)'));
				if(!wl.rVar.mailoutAllowed) cmi.push(ContextMenuItem('sep'));
			}
			// Send by email
			if(wl.rVar.mailoutAllowed){
				cmi.push(ContextMenuItem(efIcoMailout,efCaptMailout,'mailout(fL.selectedId)'));
				cmi.push(ContextMenuItem('sep'));
			}
		}
		// Multiple download
		if(f[8]||pl) {
			cmi.push(ContextMenuItem(efIcoMAdd,efCaptMAdd,((pl)?'plAdd':'mAdd')+'(fL.selectedId)'));
			cmi.push(ContextMenuItem('sep'));
		}
		// Edit
		if(f[6]) cmi.push(ContextMenuItem(efIcoEdit,efCaptEdit,'edit(fL.selectedId)'));
		// Rename
		if(f[13]) cmi.push(ContextMenuItem(efIcoRen,efCaptRen,'ren(fL.selectedId)'));
		// Execute
		if(f[14]) cmi.push(ContextMenuItem(efIcoExe,efCaptExe,'exe(fL.selectedId)'));
		// Delete
		if(f[12]) {cmi.push(ContextMenuItem('sep'));cmi.push(ContextMenuItem(efIcoSup,efCaptSup,'sup(fL.selectedId)'))}

		if(this.contextMenuExtra) this.contextMenuExtra(cmi) // If custom preview menu function, pass generated menu to function

		if(!rc && (cmi.length==(1+(isDir?1:0)))) eval(cmi[0]['action']); // Single item & left click, click-on
		else var cm=new ContextMenu(cmi,{'fade':1,'centerFirst':!rc}); // else, show context menu
	}


	/**
	 * Called on left mouse up or context menu on a FilesList item
	 * @param node n
	 * @param event e
	 * @param bool ctxm: true if called by context menu
	 */
	this.preClick=function(n,e,ctxm){
		var rc=((e && e.which == 3)||(W.event && event.button == 2)); // right-click
		var isDir=(n.id.substr(0,1)=='d'); // right-clicked file is directory
		var nid=(n.id.substr(0,3)=='_id')?n.id.substr(3):n.id.substr(1);
		var id='id'+nid;

		if(rc && !ctxm) return true; // if right click and not called by context menu, abort (will be processed by oncontextmenu call)
		rc=ctxm;

		if(isDir && !rc) go(id); // left click on directory => navigate
		if(rc) fL.cm(n,e); // right click on file or directory

		// Left click on a non-directory: set a timeout before showing context menu so user may have time to double-click
		if(!isDir && !rc) {
			if(fL.previewOnCM){
				if(typeof this.previewOnCM=='function') this.previewOnCM(id);
				else if(W.preview) preview.set(id); // If (image) preview function is present, call it
				return;
			}

			// Check if file should be viewed by default or if context menu should be displayed
			if(wl.rVar.fileViewAllowed) {
				// Generic files explorer: list of viewable files is defined
				if(W.viewableFiles){
					var e,t,f=this.files[nid][2];
					f=f.substr(f.lastIndexOf('.')+1).toLowerCase();
					for(e in W.viewableFiles) for(t in W.viewableFiles[e]) if(W.viewableFiles[e][t]==f){
						view(id);
						return false;
					}
				}
				// photo/music/video/multimedia: view file anyway
				else {
					view(id);
					return false;
				}
			}
			setTimeout(function(){fL.cm(n,e)},500)
		}

		//wl.cancelCM=wl.chrono.microtime();
		return false;
	}


	// Tooltip
	this.tt=function(n){
		if((W.dragInProgress && dragInProgress)) return false;
		if(n.tagName=='TD') n=n.parentNode;
		id=n.id
		this.selectedId='id'+id.substr(1);
		fAS(fL.filename(this.selectedId),'getFileInfo',1,false,'async');
		return '<img id="tooltipLoading" src="">';
	}

	/* Mouse (h)over / mouse out icon */
	this.mSel=0;
	this.mH=function(n){
		if(this.mSel&&this.mSel!=n) fL.mO(this.mSel); this.mSel=n;
		$(n).e.className().add('itemSel');
		tooltipDelay=2000;
		if(!this.noTooltip) tooltip(n,fL.tt)
	}
	this.mO=function(n){
		// If a context menu is displayed, don't unselect item: used not to unselect item when showing context menu in explorers
		if(dgi('contextMenuDiv')){setTimeout(function(){fL.mO(n)},100); return}

		$(n).e.className().remove('itemSel')
	}


	/**
	 * @desc Single thumbnail HTML
	 * @param f: single file description array. See efFilesJSArray and efFilePropertiesToJSArray for definition
	 * @param i: index of file in file list array
	 * @param tnw: thumbnail width
	 * @param tnh: thumbnail height
	 */
	this.iconHTML=function(f,i,tnw,tnh){
		var bw=Math.max(Math.ceil(tnw/15),5),fsw=tnw+4*bw,fsh=tnh+4*bw+0,iconH,iconSrc,eC;
		var u='<fieldset class="filesIcon" id="'+((f[1]=='d')?'d':'f')+i+'" style="width:'+fsw+'px" '+this.clickFunctions(f,i)+'>';

		var momo=' onmouseover="fL.mH(this.parentNode.parentNode)" onmouseout="fL.mO(this.parentNode.parentNode)"';

		u+='<div id="_id'+i+'" onmousedown="fL.sDF(this,\'\',event)" ';

		// Thumbnail
		if(f[17]) {
			// Extra class attributes for audio / video display
			eC=(f[5].indexOf('icoVid')!=-1)?' vid':((f[5].indexOf('icoMus')!=-1)?' mus':'');

			// Frame around image
			u+='class="img'+eC+'" style="width:'+(f[18]+2*bw+2)+'px;height:'+(f[19]+2*bw+2)+'px;margin-top:'+(bw+(tnh-f[19])/2)+'px;margin-bottom:'+((tnh-f[19])/2)+'px;position:relative">';
			// Image
			if(fL.keepScrollPos) // refreshing display: no onload animation
				u+='<img src="'+f[17]+'" style="width:'+f[18]+'px;height:'+f[19]+'px;margin-left:'+bw+'px;margin-right:'+bw+'px;margin-top:'+bw+'px"'+momo+'>';
			else
				u+='<img alt="'+f[17]+'" style="width:'+f[18]+'px;height:'+f[19]+'px;margin-left:'+bw+'px;margin-right:'+bw+'px;margin-top:'+bw+'px;visibility:hidden"'+momo+'>';
			// Video / audio overlay
			u+='<img alt="" style="position:absolute;top:50%;left:50%;margin:-16px 0 0 -16px" src="'+f[5]+'">';

			// Rating
			u+=wl.ratingItem(i,f[15],!thumbnailsSizeFactor,{'center':1,'extraStyle':'left:50%;position:absolute'})
		}

		// Icon
		else{
			iconH=(tnw>60)?tnh:32;
			iconSrc=(f[1]=='d')?((tnw==240)?efFolderIconVB:(tnw==120)?efFolderIconB:efFolderIconM):f[5];

			u+='style="position:relative;margin:0px auto 0px auto;text-align:center;width:'+(tnw+18)+'px;height:'+(tnh+12)+'px;top:5px">';
			u+='<img style="position:relative;height:'+iconH+'px;top:'+(4+Math.floor((tnh-iconH)/2))+'" src="'+iconSrc+'"'+momo+'>';

			// Rating
			if(f[1]=='f') u+=wl.ratingItem(i,f[15],!thumbnailsSizeFactor,{'center':1,'extraStyle':'left:50%;bottom:5%;position:absolute'})
		}


		u+='</div>';
		u+='<div class="fIC" id="id'+i+'" style="width:'+fsw+'px">'+f[2]+'</div>';

		return u+'</fieldset>';
	}

	/**
	 * @desc Return html onmouseX functions for managing right/left click on FilesList items
	 * @param array f: FilesList item
	 */
	this.clickFunctions=function(f,i){
		var o=' oncontextmenu="return fL.preClick(this,event,1)" onmouseup="fL.preClick(this,event)"';
		if(f[1]=='f') o+=' ondblclick="wl.cancelCM=wl.chrono.microtime()+1000;view(\'id'+i+'\')"';
		return o;
	}

	/**
	 * Create layout
	 */
	this.draw=function(){
		var tnw=this.tnw,f,i,o,u,tnh=Math.floor(tnw*3/4),fN,n,ico;

		// Remove previous DHTML elements from dd.elements
		for(o=0;o<filesListElts.length;o++) if(dd.elements[filesListElts[o]]) dd.elements[filesListElts[o]].del();
		filesListElts=[];

		if(W.filesListBeforeDraw) filesListBeforeDraw(this.files,tnw,tnh);

		// No files: display centered "no files" caption
		if(this.files.length==0) o='<table id="filesTable" style="text-align:center;width:100%;height:95%"><tr><td style="vertical-align:middle;height:10em">'+efCaptNoFile+'</td></tr></table>';
		// Icons layout
		else if(layout=='icons') {
			o='';
			if(wl.sortControls) {
				o+='<table onmousemove="eHover(event)" onmouseout="eHover()" style="text-align:right" cellspacing=0 cellpadding=0 width="100%"><colgroup><col width="20"><col width="*"><col width="80"><col width="80"><col width="80"></colgroup>';
				o+=wl.sortControls;
				o+='</table>';
			}
			o+='<div id="filesTable" style="text-align:left">';
			for(i=0;i<this.files.length;i++) o+=this.iconHTML(this.files[i],i,tnw,tnh);
			o+='</div>';
		}
		// Files layout
		else if(layout=='list') {
			o='<table id="filesTable" onmousemove="eHover(event)" onmouseout="eHover()" style="text-align:right" cellspacing=0 cellpadding=0 width="100%"><colgroup><col width="30"><col width="*"><col width="40"><col width="40"><col width="40"></colgroup>';
			if(wl.sortControls) o+=wl.sortControls;
			for(i=0;i<this.files.length;i++){
				f=this.files[i];
				o+='<tr class="eTC '+((i%2)?'even':'odd')+'" eH=1 id="'+((f[1]=='d')?'d':'f')+i+'"';

				o+=this.clickFunctions(f,i); // Context menu
				ico='<img src="'+((f[1]=='d')?efFolderIcon:f[5])+'" alt="" style="height:16px;width:16px">&nbsp;&nbsp;';

				o+='><td onmouseover="tooltip(this,fL.tt)" class="eTCLeft">';
				o+=ico+'</td>'; // Icon
				o+='<td style="text-align:left;overflow:hidden">';
				o+=((f[1]=='d')?'':wl.ratingItem(i,f[15],0,{'extraStyle':'float:right'}))
				o+='<div id="id'+i+'" class="mainCapt" onmousedown="fL.sDF(this,\'\',event)">'+ico+f[2]+'</div>'; // Name
				o+='</td>'; // Rating
				o+='<td>&nbsp;'+f[9]+'</td>'; // Size
				o+='<td>&nbsp;&nbsp;&nbsp;'+f[10]+'</td>'; // date
				o+='<td>&nbsp;&nbsp;&nbsp;'+f[11]+'</td>';
				o+='</tr>';
			}
			o+='</table>'
		}
		// 'resource'/'customIcons'
		else {
			// If function has explicitely been defined
			if(this.layoutFunction)	o=this.layoutFunction(files,tnw,tnh);
			// else use global "filesLayoutResource" function
			else o=filesLayoutResource(files,tnw,tnh);
		}

		// Insert HTML code
		if(!this.nodeId) D.write(o); else dgi(this.nodeId).innerHTML=o;

		// Icon views: start loading images
		if(this.layout!='list' && !fL.keepScrollPos) {for(i=0;i<5;i++) this.l()}

		// Chrome outside-browser drag & drop (user must press Alt key to prevent default drag):
		// add an ondragstart event to downloadable nodes, that will add DownloadURL to dataTransfer item
		for(i=0;i<this.files.length;i++) {
			f=this.files[i]
			// If file is downloadable, add download url into data-downloadURL property and dragstart event
			if(f[7]) altDragDownloadSet((dgi('_id'+i))?dgi('_id'+i):dgi('id'+i),dlURL('id'+i),f[1]=='d');
		}
		if(W.filesListAfterDraw) filesListAfterDraw(this.files,tnw,tnh);

		fL.keepScrollPos=0; // Reset info that vertical scrolling must be kept and that image must not be faded-in
	}

}


/**
 * Add Alt-drag & download (chrome) to a node
 * @param node: node that can be dragged
 * @param downloadURL: download url (with or without protocol, host & port)
 * @param isDir: true to indicate it's a directory (add a .zip extension to name)
 */
function altDragDownloadSet(node,downloadURL,isDir){
	var n=node,fN;
	if(!W.dragDownload) return;
	fN=downloadURL.substr(downloadURL.lastIndexOf('/')+1);
	fN=fN.replace(/\*weezoAmp\*/g,'&').replace(/&nbsp;/g, ' ').replace(/&amp;/g,'&').replace(/;/g,''); // Get filename for destination

	if(downloadURL.substr(0,1)=='/') downloadURL=wl.hostPortURL()+downloadURL; // Add protocol+host+port if needed
	$(n).e.statusCaptionSet(wl.capt.dragDownloadHint); // Add hint in status bar

	if(isDir)
		n.setAttribute('data-downloadURL','application/zip:'+fN+'.zip:'+downloadURL);
	else
		n.setAttribute('data-downloadURL','application/unknown:'+fN+':'+downloadURL);

	n.addEventListener('dragstart',function(event){
		if(!event || !event.altKey) return; // If user doesn't press Alt, do regular drag
		var n=event.target; while(!n.getAttribute('data-downloadURL')) n=n.parentNode;
		event.dataTransfer.setData('DownloadURL', n.getAttribute('data-downloadURL'));
		D.body.ondragstart=function(){return true};
	});
}

// Change thumnnails size factor, -1 to disable
function efTNSize(s){
	if(!dgi('efTNSize0')) return;
	var updt=s!==undefined && s!==-1;
	if(s===undefined) s=W.thumbnailsSizeFactor;
	var as; if(W.filesListDisplayed&&filesListDisplayed!='resource') as='async';
	wl.button.enable(dgi('efTNSize0'),s!==0&&s!=-1);
	wl.button.enable(dgi('efTNSize1'),s!==1&&s!=-1);
	wl.button.enable(dgi('efTNSize2'),s!==2&&s!=-1);
	if(updt) {thumbnailsSizeFactor=s;fAS(0,'efTNSize',s,0,as)}
}


/**
 * Image Preview Class
 */
function PreviewImage(){
	this.imgIndex=0;
	this.id='id0';
	this.filename='';
	this.imgLastWH;
	this.next='';
	this.prev='';
	this.angle=0;
	this.fileViewAllowed=1;
	this.slideShowActive=0;
	this.slideShowTimer=0;
	this.lastSet='';
	this.commentsEdit; // Comments edit mode, 0/1
	this.comments; // Comments
	this.ctrlsTO=0;// next/prev photo buttons fade-out timer

	this.set=function(id){
		if(dd && dd.obj) dd.obj.cancelAnim=1;
		if(dragCancelOnclick) {dragCancelOnclick=false;return;}
		if(typeof(id)=='object' && id.id) id=id.id;
		if(!id) id=this.id;
		this.id=id;
		var fn=fL.filename(id),pOF=dgi('previewOuterFrame'),lS;
		lS=((pOF)?pOF.offsetWidth+'/'+pOF.offsetHeight:'0/0')+'/'+fn;
		if(lS!=this.lastSet){
			if(pOF) {
				fAS(fn,'preview',pOF.offsetWidth,pOF.offsetHeight,true);
			}
			else {
				fAS(fn,'preview',0,0,true);
			}
			this.lastSet=lS
		}
	}

	/**
	 * Update preview image
	 */
	this.updateSrc=function(s,w,h){
		var i=1-this.imgIndex;
		var pOF=dgi('previewOuterFrame'), ePI, ePD=dgi('previewImgDiv'+i);
		if(!pOF) return;
		if(!ePD){
			ePD=D.createElement('DIV');
			ePD.id='previewImgDiv'+i;
			ePD.innerHTML='<img id="previewImg'+i+'" onclick="preview.view()" style="visibility:hidden;z-index:1;width:100%;height:100%;position:absolute;top:0;left:0">'+
				'<div id="rotateLeftBt'+i+'" class="rotateLeftBt" onclick="preview.rotateLeft()" style="visibility:hidden" title="'+wl.capt.viewRotateLeft+'"></div>'+
				'<div id="rotateRightBt'+i+'" class="rotateRightBt" onclick="preview.rotateRight()" style="visibility:hidden" title="'+wl.capt.viewRotateRight+'"></div>';
			pOF.insertBefore(ePD,pOF.firstChild);
		}
		ePI=$('previewImg'+i);
		with(ePD.style){
			position='absolute';
			width=w+'px';
			height=h+'px';
			left=((pOF.offsetWidth-w)/2)+'px';
			top=((pOF.offsetHeight-h)/2)+'px';
		}
		ePI.onload=function(){preview.switchImages()};
		ePI.src=s;

		// Add Alt-drag & download (chrome)
		altDragDownloadSet(ePI,dlURL(this.id));
	}

	// Display / hide rotation buttons on mouse over preview
	this.showRotateButtons=function(s){
		var a=$('rotateLeftBt'+this.imgIndex).e, b=$('rotateRightBt'+this.imgIndex).e;

		if(s){a.fadeIn(1);b.fadeIn(1)}
		else{a.fadeOut(500);b.fadeOut(500)}
	}

	this.setFilename=function(f){this.filename=f}
	this.setTitle=function(t){var n=dgi('previewTitle');if(n) n.innerHTML=t}

	this.commentsSet=function(c){
		if(c!==undefined)this.comments=c;
		c=this.comments;
		if(!dgi('efCommentsFrame')) return;
		var i,o='',t=[0,1,-1,0,0,1],l=[0,0,0,1,-1,1];
		for(i=5;i>=0;i--) o+='<div style="position:absolute;text-align:center;width:100%;color:#'+((i)?'555':'FFF')+';top:'+t[i]+'px;left:'+l[i]+'px">'+c+'</div>';
		dgi('efCommentsFrame').innerHTML=o
		dgi('efCommentsTextArea').value=c.replace(/&amp;/g,'&').replace(/&lt;/g,'<').replace(/&gt;/g,'>').replace(/&quot;/g,'"').replace(/<br\/>/g,"\n");
	}
	this.commentsToggle=function(){
		var e=this.commentsEdit=1-this.commentsEdit;
		dgi('editStartBt').style.display=dgi('efCommentsFrame').style.display=(e)?'none':''
		dgi('editStopBt').style.display=dgi('efCommentsForm').style.display=(e)?'':'none'
		fAS(efEditMode,'toggleComments','','',true);
		this.commentsSet();
		if(e) dgi('efCommentsTextArea').focus();
	}

	this.commentsSave=function(){
		var c=dgi('efCommentsTextArea').value.replace(/\r\n/g,'<br>');
		fAS(this.filename,'commentsSave',c,0,'async')
	}

	// Set image rating
	this.ratingSet=function(rating){
		$('previewRatingOuter').innerHTML=wl.ratingItem('preview',rating,0,{})
	}

	this.currentImg=function(){return dgi('previewImg'+this.imgIndex)}
	this.switchImages=function(){
		var i=this.imgIndex;
		if(dgi('previewImg'+i)) {
			$('previewImg'+i).e.fadeOut(150);
			$('rotateLeftBt'+i).e.fadeOut(150);
			$('rotateRightBt'+i).e.fadeOut(150);
		}
		this.imgIndex=i=1-i;
		$('previewImg'+i).e.fadeIn(150)
	}
	this.frameResized=function(){
		var pOF=dgi('previewOuterFrame'),i,lw,lh,r,rr,ePI;
		var pOFw=pOF.offsetWidth,pOFh=pOF.offsetHeight,nw,nh;
		if(this.imgLastWH==pOFw+pOFh || pOF.style.display=='none' || !pOFw || !pOFh) return;
		this.imgLastWH=pOFw+pOFh;

		for(i=0;i<2;i++) if(ePD=dgi('previewImgDiv'+i)){
			ePI=dgi('previewImg'+i);
			lw=ePI.offsetWidth;
			lh=ePI.offsetHeight;
			var r=lw/lh,rr=pOFw/pOFh;
			if(r>rr){nw=pOFw;nh=height=pOFw/r;} else {nh=pOFh;nw=width=pOFh*r}

			if(lw*lh) with(ePD.style) {
				width=nw;
				height=nh;
				left=(pOFw-nw)/2;top=(pOFh-nh)/2
			}

			if(i==this.imgIndex && (nw>lw||nh>lh) && ePI.src) this.set();
		}
	}
	/**
	 * Show preview
	 * @param id: id of item to view, false for preview item
	 * @param max: set to 1 to maximize as much as possible view window
	 */
	this.view=function(id,max) {
		if(id===undefined) id=this.id;
		if(this.fileViewAllowed) view(id,((max)?-1:false))
	}

	this.goNext=function() {this.set(this.next)}
	this.clickNext=function() {setAlpha(dgi('previewNextBt'),1);fade(dgi('previewNextBt'),1,0.7,40);preview.ctrlsTOReset(1);this.goNext()}

	this.goPrev=function() {this.set(this.prev)}
	this.clickPrev=function() {setAlpha(dgi('previewPrevBt'),1);fade(dgi('previewPrevBt'),1,0.7,40);preview.ctrlsTOReset(1);this.goPrev()}

	this.rotateLeft=function(){fAS(this.filename,'rotate'+((this.angle>0)?(this.angle-90):270),dgi("previewOuterFrame").offsetWidth,false,true);}
	this.rotateRight=function(){fAS(this.filename,'rotate'+((this.angle==270)?0:this.angle+90),dgi("previewOuterFrame").offsetWidth,false,true);}
	this.dl=function(){dl(this.id)}
	this.btDl=function(){btDl(this.id)}
	this.mAdd=function(){mAdd(this.id)}

	// Next/prev and rotation controls hide/show management
	this.ctrlsTOReset=function(mi){
		if(this.ctrlsTO) clearTimeout(preview.ctrlsTO);
		this.ctrlsTO=0;this.ctrlsTO=setTimeout(preview.ctrlsHide,((mi)?8000:1000))
	}
	this.ctrlsShow=function(){
		wl.fadeTo('previewNextBt',0.7,10);
		wl.fadeTo('previewPrevBt',0.7,10);
		preview.showRotateButtons(1)
		preview.ctrlsTOReset(1);
	}
	this.ctrlsHide=function(){
		if(preview.ctrlsTO) clearTimeout(preview.ctrlsTO); preview.ctrlsTO=0;
		wl.fadeTo('previewNextBt',0,60);
		wl.fadeTo('previewPrevBt',0,60);
		preview.showRotateButtons(0)
	}
	this.ctrlsMouseOut=function(){
		this.ctrlsTOReset(0);
	}

	// Slideshow
	this.toggleSlideshow=function(){
		this.slideShowActive=1-this.slideShowActive;
		dgi('slideShowStartButton').style.display=(this.slideShowActive)?'none':'';
		dgi('slideShowStopButton').style.display=(this.slideShowActive)?'':'none';
		if(this.slideShowActive==1) this.slideShowTimer = W.setInterval("preview.goNext()",slideShowInterval);
		else W.clearInterval(this.slideShowTimer);
	}
}

// Prevent backspace key to go back to previous page (instead try goBack function)
wl.blockBackspace();
fL=new FilesList();
