<?php
/**
 * IP locator: google maps mashup display of IP address
 *
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 4.0.1
 */

define('IP_LOCATOR_ZOOM_LEVEL',12);

require(INCLUDE_DIR.'outputFunctions.php');


$ip=@$_GET['ip'];
if (!preg_match('/^(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]\d|\d)(?:[.](?:25[0-5]|2[0-4]\d|1\d\d|[1-9]\d|\d)){3}$/',$ip)) die('IP not OK');
if(1) $tags = get_meta_tags('http://www.geobytes.com/IpLocator.htm?GetLocation&template=php3.txt&IpAddress='.$ip);

if(@$tags['latitude']=='Limit Exceeded') outDisplayErrorPage('geobytes.com limit exeeded');



WHeaders::noCache();

cfInsertHEAD(false);
?>
<script type="text/javascript">
var ipLocator={
	'mapsScriptLoaded':function(){
		var o=ipLocator.options;
		if(typeof(o.node)=='string') o.node=dgi(o.node);

		if(o.mapType=='roadmap') o.mapType=google.maps.MapTypeId.ROADMAP;
		else if(o.mapType=='hybrid') o.mapType=google.maps.MapTypeId.HYBRID;
		else o.mapType=google.maps.MapTypeId.SATELLITE;

		var opt={
			zoom:o.zoom,
			center: new google.maps.LatLng(o.lat,o.lng),
			mapTypeId: o.mapType
		};
		this.map = new google.maps.Map(o.node, opt);
	},
	'options':{
		'lat': <?php echo $tags['latitude'];?>,
		'lng': <?php echo $tags['longitude'];?>,
		'zoom': <?php echo IP_LOCATOR_ZOOM_LEVEL;?>,
		'mapType': '<?php echo ((isset($_GET['mapType']))?$_GET['mapType']:'roadmap');?>',
		'node': 'locatorMap'
	}
}

</script>
</head>
<body style="padding:0;margin:0">
	<div id="locatorMap" style="width:100%;height:100%"></div>
	<div style="position:absolute;top:5px;left:20%;width:60%;font-size:30px;font-weight:normal;color:#444;text-align:center;background:white;border:1px solid #AAA;padding:7px;margin:0"><?php echo $ip.' : '.$tags['city'].', '.$tags['country'];?></div>
	<div style="position:absolute;bottom:35px;left:10px;font-size:10px;font-weight:normal;color:#444;text-align:center;background:white;border:1px solid #AAA;padding:2px">http://www.geobytes.com</div>
<script type="text/javascript">

	var script = D.createElement("script");
	script.type = "text/javascript";
	script.src  = "http://maps.googleapis.com/maps/api/js?sensor=false&language=<?php echo cfGGetVar('language');?>&callback=ipLocator.mapsScriptLoaded";
	D.getElementsByTagName('head')[0].appendChild(script);
</script>
</body>