<?php
/**
 * Help messages
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */

require_once(INCLUDE_DIR.'outputFunctions.php');

// XML header
cfAsyncHeader();
$innerHTML="";
if(isset($_POST['hId'])){
	$innerHTML.='<div style="position:absolute; display:block; z-index:1000;" class="helpFrame wideShadow" id="helpFrame" onmouseover="if(window.disableInputs) disableInputs()" onmouseoout="if(window.enableInputs) enableInputs()">';
	$innerHTML.='<div style="position:absolute;left:0px;top:0px; width:100%; height:100%; display:block" class="helpBg"></div>';
	$innerHTML.=outThemeImage(outIcon('bulb'),false,false,'position:absolute;left:8px;top:9px;');
	$innerHTML.='<div id="helpCaptionDiv" style="padding:10px;text-align:left; position:relative">'.((@$_POST['hTId'])?'<h1>'.cfCaption($_POST['hTId']).'</h1>':'').cfCaption($_POST['hId']).'</div>';
	$innerHTML.=outImage(outIcon('closeM'),false,'onmousedown="wl.mask.hide(); if(window.dd) {dd.elements[\'helpFrame\'].hide();dd.elements[\'helpFrame\'].del()} else dgi(\'helpDiv\').innerHTML=\'\';wl.removeKeycodeListener(D)" title="'.cfCaption('genClose').'"','position:absolute;right:-12px;top:-12px;cursor:pointer');
	$innerHTML.='<input style="width:1;height:1;overflow:hidden;border:0;margin:0;padding:0" id="selInput">';
	$innerHTML.='</div>';

	$js='wl.mask.show(0,1);';
	$js.='if(!dgi("helpDiv")) {var helpDiv=D.createElement("div");';
	$js.='var helpDivId=D.createAttribute("id");';
	$js.='helpDivId.nodeValue="helpDiv";';
	$js.='helpDiv.setAttributeNode(helpDivId);';
	$js.='D.body.appendChild(helpDiv);}';

	$js.='dgi("helpDiv").innerHTML=\''.str_replace("'", "\\'",$innerHTML).'\';';
	$js.='dgi("helpFrame").style.height=(dgi("helpCaptionDiv").offsetHeight + 20)+"px";';
	$js.='wl.mask.moveAbove(dgi("helpFrame"));';
	$js.='wl.setKeycodeListener(D,function(kc){wl.mask.hide(); if(window.dd) {dd.elements[\'helpFrame\'].hide();dd.elements[\'helpFrame\'].del()} else dgi(\'helpDiv\').innerHTML=\'\';wl.removeKeycodeListener(D)});dgi("selInput").focus();';

	if(cfGetBrowser()=='ie'){
		$js.='dgi("helpFrame").style.top=(D.body.offsetHeight-200)/2;';
		$js.='dgi("helpFrame").style.left=(D.body.offsetWidth-400)/2;';
	}
	else{
		$js.='dgi("helpFrame").style.top=(window.innerHeight-300)/2;';
		$js.='dgi("helpFrame").style.left=(window.innerWidth-400)/2;';
	}
	if(cfGGetVar('allowDragNDrop')) $js.='if(W.dd && dd.elements["helpFrame"]==undefined) {ADD_DHTML("helpFrame"+NOTDROPPABLE+ISICON)}';
	echo cfAsyncXMLJSaction($js);
}

cfAsyncFooter();
?>
