<?php
/**
 * New weezo version available message box
 *
 *
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */

// Initialize script data
require_once('localFunctions.php');
lfInit();

if(!file_exists(cfAppDataDir().'/reg.ini')) {
	cfInsertHEAD();
	die('<body onload="wl.UICommand(\'close\')"></body>');
}
$regInfo=cfParse_ini_file(cfAppDataDir().'/reg.ini');
if(!isset($regInfo['regName'])) {
	cfInsertHEAD();
	die('<body onload="wl.UICommand(\'close\')"></body>');
}

$siteAdress='<center><a href="'.cfSiteLink($regInfo['regName']).'" target="_blank" style="text-decoration:underline; font-weight:bold">'.cfSiteLink($regInfo['regName']).'</a></center><br/><br/>';



/**
 * Page
 */
cfInsertHEAD(true,array('size'=>'500x270'));
?>
<body width="500" height="270" title="Weezo" oncontextmenu="return false;">
<?php
echo outDivFrame('frame2',false,'margin-top:10px');
echo outImage(outIcon('appIcon'),false,false,'float:left; margin-right:2em; margin-bottom:1em');
echo cfCaption('newAccountCreated', $siteAdress);

// Save / Cancel buttons
	echo '<div style="position:relative; top:-4px; text-align:center; width:100%">'.outButton(cfCaption('genOK'),'javascript:wl.UICommand(\'close\')',outIcon('ok'));
	echo '</div></div>';
?>
<script type="text/javascript">
wl.UICommand('fadeSize','500x270');
</script>
</body></html>